# cmap(b1x)				valore x del border sinistro
# cmap(b2x)				valore x del border destro
# cmap(c1rgb)			valori rgb del border sinistro
# cmap(c2rgb)			valori rgb del border destro
# cmap(currTagId)		valore id(canvas) dell'item	
# cmap(currTagType)		bound || normal
# cmap(currTagX)		valore x del colore corrente
# cmap(currTagScaledX)	valore x in decimale
# cmap(currTagCol)		valori rgb del colore corrente
# cmap(currTagName)		nome con numero progressivo (es.: c2)
# cmap(currMapName)		nome mappa corrente
# cmap(infoText)		label di info
# cmap(nOfCls)			numero di colori presenti (quantita')

proc _cMapWin_ {} {
	global seText
	if [winfo exists .cmp] {
		if ![winfo viewable .cmp] {
			set i [$seText search "SpectrumOfColors " 1.0]
			if {$i!=""} {_updateCmapWin_ $i} 
			wm deiconify .cmp
		}
		focus .cmp
		return
	}
	global cmap se
	toplevel .cmp
	# wm geometry .cmp +[winfo pointerx .]+[winfo pointery .]
	wm geometry .cmp +[winfo pointerx .]+[winfo pointery .]
	wm transient .cmp .
	wm title .cmp "Spectrum of colors"
	wm resizable .cmp 0 0
	wm protocol .cmp WM_DELETE_WINDOW {wm withdraw .cmp}
	bind .cmp <Escape> {wm withdraw .cmp}
	# 
	# Menus
	# 
	menu .cmp.m1 -tearoff 0
	# _colorCells_ setta il comando:
	.cmp.m1 add command -label "Add color"
	.cmp.m1 add command -label "Add specified color ..."
	.cmp.m1 add separator
	.cmp.m1 add command -label "Apply to current shader" -command {_updateText_ soc}
	.cmp.m1 add command -label "Save map" -command _saveMap_
	.cmp.m1 add cascade -label "Load map" -menu .cmp.m3
	.cmp.m1 add command -label "Maps management ..." -command _socWin_
	.cmp.m1 add separator
	.cmp.m1 add command -label "Clear/reset current map" -command _resetMap_
	.cmp.m1 add command -label "Hide map editor" -command {wm withdraw .cmp}
	menu .cmp.m2 -tearoff 0
	.cmp.m2 add command -label "Pick a color ..." -command _pickColor_
	.cmp.m2 add cascade -label "Copy from" -menu .cmp.m2.m
	.cmp.m2 add separator
	.cmp.m2 add command -label "Delete" -command _delColor_
	menu .cmp.m2.m -tearoff 0
	menu .cmp.m3 -tearoff 0
	# 
	# Commentare nella versione finale:
	#######################
	#	bind .cmp <Control-x> {
	#		destroy .cmp
	#		source src/cmap.tcl
	#		source src/cmapFiles.tcl
	#		_cMapWin_
	#	}
	#######################
	_createCanvas_
	_colorCells_
	# 
	# Frame colore corrente e scales
	# 
	frame .cmp.f -relief sunken -bd 1.2
	pack .cmp.f -fill both -expand 1
	frame .cmp.f.c
	frame .cmp.f.c.cf -height 30; # color frame
	_bindEnterLeave_ .cmp.f.c.cf cmap(infoText) "LeftMB to pick a color"
	bind .cmp.f.c.cf <ButtonPress-1> _pickColor_
	label .cmp.f.c.p -width 6 -relief sunken -textvar cmap(currTagScaledX)
	pack .cmp.f.c.cf .cmp.f.c.p -fill x
	frame .cmp.f.s; # scales RGBA
	foreach v {r g b a} {
		scale .cmp.f.s.$v -orient horiz -from 0 -to 1 -res 0.001 -width 8 -showv 0 \
			-leng 200 -var cmap(currC$v) -command _colorScaleComm_
		pack .cmp.f.s.$v
	}
	_scaleBindings_
	# 
	# Labels di info:
	# 
	frame .cmp.l -relief sunken -bd 1.2
	label .cmp.l.l0 -fg white -text " RGBA"
	label .cmp.l.r -fg blue -textvar cmap(currCr)
	label .cmp.l.g -fg blue -textvar cmap(currCg)
	label .cmp.l.b -fg blue -textvar cmap(currCb)
	label .cmp.l.a -fg blue -textvar cmap(currCa)
	pack .cmp.l.l0 .cmp.l.r .cmp.l.g .cmp.l.b .cmp.l.a -side left
	label .cmp.l.l1 -fg white -textvar cmap(infoText)
	pack .cmp.l.l1 -side right
	pack .cmp.l -fill x
	# 
	# Maps archive and current name
	# 
	frame .cmp.f.f
	entry .cmp.f.f.e -textvar cmap(currMapName)
	_bindEnterLeave_ .cmp.f.f.e cmap(infoText) "Current map name"
	pack .cmp.f.f.e -fill x -expand 1
	frame .cmp.f.f.d -relief ridge -bd 2; # maps file dir
	label .cmp.f.f.d.lb -textvar se(currMpFileName)
	button .cmp.f.f.d.b -image $se(opIm) -command {_setMpFile_ Open}
	_bindEnterLeave_ .cmp.f.f.d.b cmap(infoText) "Select archive file"
	button .cmp.f.f.d.bn -image $se(nwIm) -command {_setMpFile_ Save}
	_bindEnterLeave_ .cmp.f.f.d.bn cmap(infoText) "Create new archive file"
	pack .cmp.f.f.d -fill x
	pack .cmp.f.f.d.lb -side left -anchor w
	pack .cmp.f.f.d.bn .cmp.f.f.d.b -side right -fill y -anchor e
	frame .cmp.f.f.m -relief ridge -bd 2; # bottoni-icone
	button .cmp.f.f.m.b1 -image $se(apIm) -command {_updateText_ soc; wm withdraw .cmp}
	button .cmp.f.f.m.b2 -image $se(svIm) -command _saveMap_
	button .cmp.f.f.m.b3 -image $se(ldIm)
	bind .cmp.f.f.m.b3 <ButtonRelease-1> {tk_popup .cmp.m3 %X %Y}
	button .cmp.f.f.m.b4 -image $se(mgIm) -command _socWin_
	button .cmp.f.f.m.b5 -image $se(nwIm) -command _resetMap_
	button .cmp.f.f.m.b6 -image $se(clIm) -command {wm withdraw .cmp}
	_bindEnterLeave_ .cmp.f.f.m.b1 cmap(infoText) "Apply to current shader"
	_bindEnterLeave_ .cmp.f.f.m.b2 cmap(infoText) "Save current map"
	_bindEnterLeave_ .cmp.f.f.m.b3 cmap(infoText) "Load map ..."
	_bindEnterLeave_ .cmp.f.f.m.b4 cmap(infoText) "Maps management ..."
	_bindEnterLeave_ .cmp.f.f.m.b5 cmap(infoText) "Clear/reset current map"
	_bindEnterLeave_ .cmp.f.f.m.b6 cmap(infoText) "Hide map editor"
	pack .cmp.f.f.m -fill x -expand 1
	pack .cmp.f.f.m.b1 .cmp.f.f.m.b2 .cmp.f.f.m.b3 .cmp.f.f.m.b4 .cmp.f.f.m.b5 \
		.cmp.f.f.m.b6 -side left -fill both -expand 1
	
	pack .cmp.f.c .cmp.f.s -side left -anchor n
	pack .cmp.f.f -side left -anchor n -fill x -expand 1
	# 
	# Inizializza i due borders
	# 
	_initMap_ {0.000 0.000 0.000} {1.000 1.000 1.000}
	# 
	# Lista le maps disponibili in $se(currMpFilePath)
	# 
	_listMapsInMenu_ $se(currMpFilePath)
	set i [$seText search "SpectrumOfColors " 1.0]
	if {$i!=""} {_updateCmapWin_ $i} 
	# 
	# Prove di inserimento colori:
	# 
	# _provaColori_
}

proc _provaColori_ {} {
	_addNewColor_ 100 {1.000 0.800 0.500} normal 0.000
	_addNewColor_ 200 {0.300 0.800 0.900} normal 0.000
	_addNewColor_ 300 {0.500 0.200 0.100} normal 0.000
}

proc _scaleBindings_ {} {
	.cmp.f.s.a config -troughcolor grey90
	bind .cmp.f.s.r <ButtonRelease-1> _scaleRelease_
	bind .cmp.f.s.g <ButtonRelease-1> _scaleRelease_
	bind .cmp.f.s.b <ButtonRelease-1> _scaleRelease_
	bind .cmp.f.s.a <ButtonRelease-1> _scaleRelease_
}

proc _setCurrColor_ {id} {
	global cmap
	set ctags [.cmp.c gettags $id]
	set cmap(currTagId) $id
	set cmap(currTagType) [lindex $ctags 5]
	set cmap(currTagX) [_frameCoord_ $id]
	set cmap(currTagScaledX) [_frameN2float_ $id]
	set cmap(currTagCol) [lrange $ctags 1 3]
	set cmap(currTagName) [lindex $ctags 4]
	set cmap(currCr) [lindex $cmap(currTagCol) 0]
	set cmap(currCg) [lindex $cmap(currTagCol) 1]
	set cmap(currCb) [lindex $cmap(currTagCol) 2]
	set cmap(currCa) [lindex $ctags 6]
	_colorScaleComm_ null
	.cmp.c raise current all
	_setBorders_ $id
	.cmp.c itemconfigure ctag -fill black
	.cmp.c itemconfigure $id -fill red
}

proc _colorScaleComm_ {v} {
	global cmap
	.cmp.f.c.cf config -bg [_exaColor_ $cmap(currCr) $cmap(currCg) $cmap(currCb)]
}

proc _scaleRelease_ {} {
	global cmap
	set currtags [.cmp.c gettags $cmap(currTagId)]
	set rgb "$cmap(currCr) $cmap(currCg) $cmap(currCb)"
	set newtags [lreplace $currtags 1 3 $cmap(currCr) $cmap(currCg) $cmap(currCb)]
	set newtags [lreplace $newtags 6 6 $cmap(currCa)]
	.cmp.c itemconfigure $cmap(currTagId) -tags $newtags
	_gradient_ [_frameCoord_ $cmap(currTagId)] $rgb
}

proc _initMap_ {start end} {
	global cmap
	_addNewColor_ 0 $start bound 0.000
	_addNewColor_ 500 $end bound 0.000
	set cmap(b1x) 0
	set cmap(b2x) 500
	set cmap(c1rgb) $start
	set cmap(c2rgb) $end
	_gradient_ 500 [split $end]
	_setCurrColor_ [lindex [.cmp.c find withtag bound] end]
	set cmap(currMapName) map1
}

proc _createCanvas_ {} {
	global cmap
	canvas .cmp.c -width 510 -height 60
	pack .cmp.c -padx 4 -pady 4
	.cmp.c bind ctag <Enter>           {_itemEnter_}
	.cmp.c bind ctag <Leave>           {_itemLeave_}
	.cmp.c bind ctag <ButtonPress-1>   {_itemPress_ %x}
	.cmp.c bind ctag <B1-Motion>       {_itemMove_ %x}
	.cmp.c bind ctag <ButtonRelease-1> {_itemRelease_}
	.cmp.c bind ctag <ButtonPress-2>   {}
	.cmp.c bind ctag <ButtonPress-3>   {_itemPress3_ %x %X %Y}
}

proc _colorCells_ {} {
	global cmap
	frame .cmp.c.f -width 500 -height 40 -relief sunken -bd 1.2
	bind .cmp.c.f <Enter> {set cmap(infoText) "RightMB: options"}
	bind .cmp.c.f <Leave> {set cmap(infoText) ""}
	# 
	# 501 celle da 1 pixel:
	# 
	for {set n 0} {$n<=500} {incr n} {
		frame .cmp.c.f.$n -width 1 -height 40
		bind .cmp.c.f.$n <ButtonRelease-3> "
			tk_popup .cmp.m1 %X %Y
			.cmp.m1 entryconfigure 0 -command {_addColor_ $n}
			.cmp.m1 entryconfigure 1 -command {_addColorPick_ $n}
		"
		pack .cmp.c.f.$n -fill y -side left
	}
	# a mezza larghezza freccia: 5
	.cmp.c create window 4 5 -window .cmp.c.f -anchor nw
}

proc _frameCoord_ {id} {
	# 
	# Restituisce la coordinata x del colTag $id (equivalente alla frame da colorare)
	# 
	return [format %.0f [expr [lindex [.cmp.c coords $id] 0] -5]]
}

proc _frameN2float_ {id} {
	# 
	# Restituisce la coordinata x del colTag $id come 0.000-1.000
	# 
	return [format %.3f [expr [_frameCoord_ $id] /500.000]]
}

proc _itemEnter_ {} {
	global cmap
	set name [lindex [.cmp.c gettags current] 4]
	if {$name!="$cmap(currTagName)"} {
		.cmp.c itemconfigure current -fill white
	}
	set tags [.cmp.c gettags current]
	set n [string trimleft $name c]
 	set cmap(infoText) \
		"Color $n ([lrange $tags 1 3] [lindex $tags 6]) RightMB: options"
}

proc _itemLeave_ {} {
	global cmap
	set name [lindex [.cmp.c gettags current] 4]
	set cmap(infoText) {}
	if {$name!="$cmap(currTagName)"} {
		.cmp.c itemconfigure current -fill black
	}
}

proc _itemPress_ {x} {
	global anchor
	set anchor $x
	_setCurrColor_ [.cmp.c find withtag current]
}

proc _itemMove_ {x} {
	global anchor cmap
	if {$cmap(currTagType)=="bound"} return
	set x1 $anchor
	set anchor $x
	set dx [expr $x - $x1]
	set cx [_frameCoord_ $cmap(currTagId)]
	if {$cx + $dx > $cmap(b2x)} return
 	if {$cx + $dx < $cmap(b1x)} return
	.cmp.c move $cmap(currTagId) $dx 0
	set cmap(currTagX) [_frameCoord_ $cmap(currTagId)]
	set cmap(currTagScaledX) [_frameN2float_ $cmap(currTagId)]
	# 
	# Interactive:
	# 
	# _gradient_ [expr $cx + $dx] $cmap(currTagCol)
}

proc _itemRelease_ {} {
	global cmap
	if {$cmap(currTagType)=="bound"} return
	set cx [_frameCoord_ $cmap(currTagId)]
	_gradient_ $cx $cmap(currTagCol)
	set name [lindex [.cmp.c gettags current] 4]
	if {$name=="$cmap(currTagName)"} return
	.cmp.c itemconfigure $cmap(currTagId) -fill black
}

proc _itemPress3_ {x X Y} {
	global cmap
	_itemPress_ $x
	set type [lindex [.cmp.c gettags current] 5]
	.cmp.m2 entryconfigure 3 -state normal
	if {$type=="bound"} {.cmp.m2 entryconfigure 3 -state disabled}
	.cmp.m2.m delete 0 end
	for {set n 1} {$n<=$cmap(nOfCls)} {incr n} {
		.cmp.m2.m add command -label "Color $n" -command "_copyColor_ $n"
	}
	set i [expr [string trimleft $cmap(currTagName) c] -1]
	.cmp.m2.m entryconfigure $i -state disabled
	tk_popup .cmp.m2 $X $Y
}

proc _addNewColor_ {args} {
	set x    [lindex $args 0]
	set rgb  [lindex $args 1]
	set type [lindex $args 2]
	set a    [lindex $args 3]; # alpha
	# Triangolino-freccia, larghezza alla base 10:
	set x0 [expr $x +5]; set x1 [expr $x +10]; set x2 $x
	set r [lindex $rgb 0]; set g [lindex $rgb 1]; set b [lindex $rgb 2]
	# Tags: ctag (comune) r g b c{numero_sequenziale} normal/bound
	# il numero_sequenziale viene aggiornato ad ogni _addNewColor_ per mezzo di
	# _renumberColors_
	set newId \
		[.cmp.c create polygon $x0 48 $x1 60 $x2 60 -tags "ctag $r $g $b cn $type $a"]
	_renumberColors_
	if {$type=="bound"} return
	_setCurrColor_ $newId
	_setBorders_ $newId
	_gradient_ $x $rgb
}

proc _renumberColors_ {} {
	# 
	# Rinomina i colori da 1 a n sequenziale da sx a dx
	# 
	global cmap
	set idList [.cmp.c find withtag ctag]
	foreach i $idList {
		set ix [_frameCoord_ $i]
		lappend ilist "$ix $i"
	}
	set sorted [lsort -integer -index 0 $ilist]; # In funzione della posizione in x
	set cnt 1
	foreach i $sorted {
		set tagId [lindex $i 1]
		set currtags [.cmp.c gettags $tagId]
		set newtags [lreplace $currtags 4 4 c$cnt]
		.cmp.c itemconfigure $tagId -tags $newtags
		incr cnt
	}
	set cmap(nOfCls) [expr $cnt -1]
}

proc _setBorders_ {id} {
	global cmap
	# 
	# Setta cmap(b1x) cmap(b2x) cmap(c1rgb) cmap(c2rgb)
	# 
	set currTagNmb [string trimleft $cmap(currTagName) c]
	set bt1Id [.cmp.c find withtag c[expr $currTagNmb -1]]
	set bt2Id [.cmp.c find withtag c[expr $currTagNmb +1]]
	set cmap(b1x) [_frameCoord_ $bt1Id]
	set cmap(b2x) [_frameCoord_ $bt2Id]
	set cmap(c1rgb) [lrange [.cmp.c gettags $bt1Id] 1 3]
	set cmap(c2rgb) [lrange [.cmp.c gettags $bt2Id] 1 3]
	if {$currTagNmb==1} {set cmap(b1x) 0}
	if {$currTagNmb>1&&$cmap(currTagType)=="bound"} {set cmap(b2x) 500}
}

proc _gradient_ {cx rgb} {
	global cmap cImage
	set fD1 [expr $cx - $cmap(b1x)]
	set fD2 [expr $cmap(b2x) - $cx]
	if {$fD1!=0} {
		set rD1 [expr ([lindex $cmap(c1rgb) 0]-[lindex $rgb 0])/$fD1]
		set gD1 [expr ([lindex $cmap(c1rgb) 1]-[lindex $rgb 1])/$fD1]
		set bD1 [expr ([lindex $cmap(c1rgb) 2]-[lindex $rgb 2])/$fD1]
		set r [lindex $cmap(c1rgb) 0]
		set g [lindex $cmap(c1rgb) 1]
		set b [lindex $cmap(c1rgb) 2]
		for {set f $cmap(b1x)} {$f<=$cx} {incr f} {
			.cmp.c.f.$f config -bg [_exaColor_ $r $g $b]
#			$cImage put [_exaColor_ $r $g $b] -to $f 0 [expr $f +1] 40
			set r [expr $r - $rD1]
			set g [expr $g - $gD1]
			set b [expr $b - $bD1]
			if {$r>1} {set r 1.0}; if {$r<0} {set r 0.0}
			if {$g>1} {set g 1.0}; if {$g<0} {set g 0.0}
			if {$b>1} {set b 1.0}; if {$b<0} {set b 0.0}
		}
	}
	if {$fD2!=0} {
		set rD2 [expr ([lindex $cmap(c2rgb) 0]-[lindex $rgb 0])/$fD2]
		set gD2 [expr ([lindex $cmap(c2rgb) 1]-[lindex $rgb 1])/$fD2]
		set bD2 [expr ([lindex $cmap(c2rgb) 2]-[lindex $rgb 2])/$fD2]
		set r [lindex $rgb 0]
		set g [lindex $rgb 1]
		set b [lindex $rgb 2]
		for {set f $cx} {$f<=$cmap(b2x)} {incr f} {
			.cmp.c.f.$f config -bg [_exaColor_ $r $g $b]
#			$cImage put [_exaColor_ $r $g $b] -to $f 0 [expr $f +1] 40
			set r [expr $r + $rD2]
			set g [expr $g + $gD2]
			set b [expr $b + $bD2]
			if {$r>1} {set r 1.0}; if {$r<0} {set r 0.0}
			if {$g>1} {set g 1.0}; if {$g<0} {set g 0.0}
			if {$b>1} {set b 1.0}; if {$b<0} {set b 0.0}
		}
	}
}

proc _addColor_ {x} {
	# 
	# Aggiunge un colore di valore rgb eguale alla frame sotto il mouse cursor
	# 
	set fg [.cmp.c.f.$x cget -bg]
	set rgb [_rgbColor_ $fg]
	_addNewColor_ $x $rgb normal 0.000
}

proc _addColorPick_ {x} {
	set col [tk_chooseColor -parent .cmp]
	if {$col==""} return
	global cmap
	catch {_rgbColor_ $col} rgb
	_addNewColor_ $x $rgb normal 0.000
}

proc _delColor_ {} {
	global cmap
	set x [_frameCoord_ $cmap(currTagId)]
	.cmp.c delete $cmap(currTagId)
	_renumberColors_
	set prevTagName c[expr [string trimleft $cmap(currTagName) c] -1]
	set prevTagId [.cmp.c find withtag $prevTagName]
	_setCurrColor_ $prevTagId
	_setBorders_ $prevTagId
	if {$prevTagName=="c1"} {set cmap(b1x) 0}
	set x [_frameCoord_ $prevTagId]
	set rgb [lrange [.cmp.c gettags $prevTagId] 1 3]
	_gradient_ $x $rgb
}

proc _copyColor_ {n} {
	global cmap
	set tags [.cmp.c gettags [.cmp.c find withtag c$n]]
	set r [lindex $tags 1]
	set g [lindex $tags 2]
	set b [lindex $tags 3]
	set a [lindex $tags 6]
	set cmap(currCr) $r
	set cmap(currCg) $g
	set cmap(currCb) $b
	set cmap(currCa) $a
	_colorScaleComm_ null
	_scaleRelease_
}

proc _pickColor_ {} {
	set ccol [.cmp.f.c.cf cget -bg]
	set col [tk_chooseColor -parent .cmp -initialcolor $ccol]
	if {$col==""} return
	global cmap
	catch {_rgbColor_ $col} rgb
	set cmap(currCr) [lindex $rgb 0]
	set cmap(currCg) [lindex $rgb 1]
	set cmap(currCb) [lindex $rgb 2]
	_colorScaleComm_ null
	_scaleRelease_
}

proc _resetMap_ {} {
	.cmp.c delete ctag
	_initMap_ {0.000 0.000 0.000} {1.000 1.000 1.000}
}

