proc _saveMap_ {} {
	global cmap se tmpDir
	set cmap(currMapName) [join $cmap(currMapName) _]
	if {$cmap(currMapName)==""} return
	set cmf $se(currMpFilePath)
	if ![file exists $cmf] {
		set cf [open $cmf w]
		_writeMapToFile_ $cf 1
		close $cf
		_listMapsInMenu_ $cmf
		return
	}
	set replaced 0
	set tmpfn $tmpDir/Vse_MpArchive.vm
	set tmpf [open $tmpfn w]
	set cf [open $cmf r]
	while {[gets $cf line]>=0} {
		if [string match "Declare $cmap(currMapName) = SpectrumOfColors (" $line] {
			_writeMapToFile_ $tmpf 0
			while {$line!=""} {gets $cf line}
			set replaced 1
		}
		puts $tmpf $line
	}
	if {$replaced==0} {_writeMapToFile_ $tmpf 1}
	close $tmpf
	close $cf
	if [file exists $cmf] {file delete $cmf}
	file copy $tmpfn $se(currMpFilePath)
	_listMapsInMenu_ $se(currMpFilePath)
}

proc _writeMapToFile_ {f nl} {
	global cmap
	puts $f "Declare $cmap(currMapName) = SpectrumOfColors ("
	for {set n 1} {$n<$cmap(nOfCls)} {incr n} {
		set x1 [_frameN2float_ [.cmp.c find withtag c$n]]
		set x2 [_frameN2float_ [.cmp.c find withtag c[expr $n+1]]]
		if {$x2==1.000} {set x2 1.001}
		set ctags1 [.cmp.c gettags c$n]
		set ctags2 [.cmp.c gettags c[expr $n+1]]
		set rgba1 [join "[lrange $ctags1 1 3] [lindex $ctags1 6]" ,]
		set rgba2 [join "[lrange $ctags2 1 3] [lindex $ctags2 6]" ,]
		puts $f "  \[$x1,'$rgba1',$x2,'$rgba2'\]"
	}
	if {$nl==1} {puts $f ")\n"}
	if {$nl==0} {puts $f ")"}
}

proc _loadCmap_ {filePath mname} {
	global cmap
	.cmp.c delete ctag
	set f [open $filePath r]
	while {[gets $f line]>=0} {
		if [string match "Declare $mname = SpectrumOfColors (" $line] {
			while {$line!= ")"} {
				gets $f line
				if {$line!= ")"} {
					set type normal
					set l [split [string trim $line " \[\]"] ,]
					set x [format %.0f [expr [lindex $l 0] *500]]
					set r [string trim [lindex $l 1] ']
					set g [lindex $l 2]
					set b [lindex $l 3]
					set a [string trim [lindex $l 4] ']
					set rgb "$r $g $b"
					if {$x==0} {set type bound}
					_addNewColor_ $x $rgb $type $a
				}
			}
			# 
			# Ultima linea:
			# 
			set r [string trim [lindex $l 6] ']
			set g [lindex $l 7]
			set b [lindex $l 8]
			set a [string trim [lindex $l 9] ']
			set rgb1 "$r $g $b"
			_addNewColor_ 500 $rgb1 bound $a
			set cmap(b1x) $x
			set cmap(b2x) 500
			set cmap(c1rgb) $rgb
			set cmap(c2rgb) $rgb1
			_gradient_ 500 $rgb1
			_setCurrColor_ [lindex [.cmp.c find withtag bound] end]
		}
	}
	close $f
	set cmap(currMapName) $mname
}

proc _updateCmapWin_ {i} {
	# 
	# i e' l'indice di seText alla linea SpectrumOfColor
	# 
	global seText cmap
	.cmp.c delete ctag
	set ei [$seText search ")" $i]
	set nl [expr ([lindex [split $ei .] 0]-[lindex [split $i .] 0])-1]
	for {set n 1} {$n<=$nl} {incr n} {
		set type normal
		set ind [expr $i + $n.0]
		set line [$seText get $ind "$ind lineend"]
		set l [split [string trim $line " \[\]"] ,]
		set x [format %.0f [expr [lindex $l 0] *500]]
		set r [string trim [lindex $l 1] ']
		set g [lindex $l 2]
		set b [lindex $l 3]
		set a [string trim [lindex $l 4] ']
		set rgb "$r $g $b"
		if {$x==0} {set type bound}
		_addNewColor_ $x $rgb $type $a
	}
	# 
	# Ultima linea:
	# 
	set r [string trim [lindex $l 6] ']
	set g [lindex $l 7]
	set b [lindex $l 8]
	set a [string trim [lindex $l 9] ']
	set rgb1 "$r $g $b"
	_addNewColor_ 500 $rgb1 bound $a
	set cmap(b1x) $x
	set cmap(b2x) 500
	set cmap(c1rgb) $rgb
	set cmap(c2rgb) $rgb1
	_gradient_ 500 $rgb1
	_setCurrColor_ [lindex [.cmp.c find withtag bound] end]
}

proc _socWin_ {} {
	global se
	toplevel .lw
	wm geometry .lw +[winfo pointerx .]+[winfo pointery .]
	wm transient .lw .
	wm title .lw "S.o.c. manager"; # NON CAMBIARE IL TITOLO
	wm resizable .lw 0 0
	bind .lw <Escape> {destroy .lw; grab .}
	frame .lw.f
	pack .lw.f
	frame .lw.f.f1
	frame .lw.f.f2
	pack .lw.f.f1 .lw.f.f2 -side left -fill both -expand 1
	frame .lw.f.f1.f -relief ridge -bd 2; # archive file 1
	label .lw.f.f1.f.lb -text $se(mapFile1) -textvariable se(mapFile1)
	button .lw.f.f1.f.b -image $se(opIm) -command "_setMapFile_ 1"
	_bindEnterLeave_ .lw.f.f1.f.b se(infoText) "RighMB: clear"
	bind .lw.f.f1.f.b <ButtonRelease-3> {
		.lw.m2 entryconfigure 0 -command {_clearMapsLbox_ 1}
		tk_popup .lw.m2 %X %Y
	}
	frame .lw.f.f2.f -relief ridge -bd 2; # archive file 1
	label .lw.f.f2.f.lb -text $se(mapFile2) -textvariable se(mapFile2)
	button .lw.f.f2.f.b -image $se(opIm) -command "_setMapFile_ 2"
	_bindEnterLeave_ .lw.f.f2.f.b se(infoText) "RightMB: clear"
	bind .lw.f.f2.f.b <ButtonRelease-3> {
		.lw.m2 entryconfigure 0 -command {_clearMapsLbox_ 2}
		tk_popup .lw.m2 %X %Y
	}
	pack .lw.f.f1.f .lw.f.f2.f -fill x
	pack .lw.f.f1.f.lb .lw.f.f2.f.lb -side left -anchor w
	pack .lw.f.f1.f.b .lw.f.f2.f.b -side right -fill y -anchor e
	set se(SLlbox1) [_insertLbox_ .lw.f.f1.l 16 {}]
	set se(SLlbox2) [_insertLbox_ .lw.f.f2.l 16 {}]
	bind $se(SLlbox1) <ButtonRelease-3> {_bindMapRel3_ 1 %y %X %Y}
	bind $se(SLlbox2) <ButtonRelease-3> {_bindMapRel3_ 2 %y %X %Y}
	_insertUpDownDelSide_ r .lw.f.f1.sl $se(SLlbox1) $se(SLlbox2) 1
	_insertUpDownDelSide_ l .lw.f.f2.sl $se(SLlbox2) $se(SLlbox1) 2
	_bindEnterLeave_ .lw.f.f1.sl se(infoText) "Move or delete (X) selected"
	_bindEnterLeave_ .lw.f.f2.sl se(infoText) "Move or delete (X) selected"
	_insertApplyDismiss_ .lw.ok "Save" .lw . {
		_applyMapsLibraryChanges_ 1
		_applyMapsLibraryChanges_ 2
		destroy .lw
	}
	if {$se(mapFile1)!=""} {_listLibMaps_ 1}
	if {$se(mapFile2)!=""} {_listLibMaps_ 2}
	menu .lw.m -tearoff 0
	# .lw.m add command -label "View"   -command _viewShader_
	.lw.m add command -label "Rename" -command _renameLibShaderWin_
	menu .lw.m2 -tearoff 0
	.lw.m2 add command -label "Clear"
	# 
	# txt da nascondere:
	# 
	set se(libTxt1) [text .lw.f.f1.t -width 2 -height 24 -wrap none]
	set se(libTxt2) [text .lw.f.f2.t -width 2 -height 24 -wrap none]
	# pack .lw.f.f1.t .lw.f.f2.t -fill x
	_loadTmpMapsContent_ $se(mapPath1) 1
	_loadTmpMapsContent_ $se(mapPath2) 2
	grab .lw
}

proc _setMapFile_ {n} {
	global se tmpDir
	if {$se(mapChanged)==1} {
		set answer [tk_messageBox -icon question -parent .lw -title "" \
			-type yesnocancel -message "Save $se(mapFile1) $se(mapFile2) changes ?"]
		switch -- $answer {
			yes {_applyMapsLibraryChanges_ $n; _clearMapsLbox_ $n}
			no {_clearMapsLbox_ 1; _clearMapsLbox_ 2}
			cancel return
		}
		
		set se(libChanged) 0
	}
	set types {{{Vse maps files} .vm}}
	set iniDir [file dirname [set se(mapPath$n)]]
	set fname [tk_getOpenFile -filetypes $types \
			-defaultextension .vs -title "Select file" -parent .lw \
			-initialdir $iniDir \
			-initialfile [set se(mapFile$n)]
		]
	if {$fname==""} return
	_clearMapsLbox_ $n
	set se(mapPath$n) $fname
	set se(mapFile$n) [file tail $fname]
	if {$se(mapPath1)=="$se(mapPath2)"} {
		tk_messageBox -icon error -parent .lw -title "" -type ok \
			-message "Files are identical"
		_clearMapsLbox_ $n
		return
	}
	_listLibMaps_ $n
	_loadTmpMapsContent_ $fname $n
}

proc _clearMapsLbox_ {n} {
	global se
	[set se(SLlbox$n)] delete 0 end
	[set se(libTxt$n)] delete 1.0 end
	set se(mapFile$n) {}
	set se(mapPath$n) [file dirname $se(mapPath$n)]/NULL
}

proc _listLibMaps_ {n} {
	global se
	_listAvMaps_ [set se(mapPath$n)] $se(SLlbox$n)
}

proc _listAvMaps_ {sfile lbox} {
	$lbox delete 0 end
	set f [open $sfile r]
	while {[gets $f line]>=0} {
		if [string match {Declare * =*} $line] {
			$lbox insert end [lindex $line 1]
		}
	}
	close $f
}

proc _loadTmpMapsContent_ {fname n} {
	if ![file exists $fname] return
	global se
	set t [set se(libTxt$n)]
	set f [open $fname r]
	set name [file rootname [file tail $fname]]
	$t delete 1.0 end
	$t insert end [read $f]
	set all [join [$t get 1.0 end]]
	if {$all==""} {$t delete 1.0 end}; # altrimenti lascia un a capo vuoto nel txt
	close $f
}

proc _bindMapRel3_ {n y X Y} {
	global se
	set lb [set se(SLlbox$n)]
	$lb selection clear 0 end
	set i [$lb nearest $y]
	$lb selection set $i
	set name [$lb get $i]
	if {$name!=""} {tk_popup .lw.m $X $Y; set se(currLibLbox) $n}
}
