proc _packOptions_ {type} {
	if {$type=="plain"} {pack forget .f1.o2}
	if {$type=="pattern"} {pack .f1.o2 -fill x -padx 4 -pady 2}
}

proc _clearCurrentShader_ {} {
	global se seText tmpDir
	if {$se(currShName)==""} return
	set answer [tk_messageBox -message "All unsaved data will be lost!\n\
		Do you really want to continue?" -parent . \
		-title "Shader" -type okcancel -icon question]
	switch -- $answer {
		ok {
			_clearTmpDir_ $se(currShName)
			_resetCurrentShader_
			if {$se(scope)=="plain"} {set t PlainSurface}
			if {$se(scope)=="pattern"} {set t PatternSurface}
			_state_ $seText normal
			$seText insert end "Declare $se(currShName) =\n"
			$seText insert end "Shader \[\n  $t \[\n  \]\n\]\n"
			_state_ $seText disabled
			file copy -force icons/nr.png $tmpDir/Vse_$se(currShName).png
		}
		cancel {}
	}
}

proc _resetCurrentShader_ {} {
	global seText se
	_state_ $seText normal
	$seText delete 1.0 end
	.f2.tr.s delete 0 end
	.f2.tr.r delete 0 end
	_state_ $seText disabled
	_shaderDefaults_
}

proc _newShader_ {type} {
	global seText plSur se gui outputFile tmpDir
	set newName unnamed$se(counter)
	if {[lsearch $se(currList) $newName]!=-1} {
		incr se(counter)
		_newShader_ $type
		return
	}
	_saveCurrentDef_
	_resetCurrentShader_
	if {$type=="plain"} {
		set t PlainSurface
		if [winfo exists .cmp] {wm withdraw .cmp}
	}
	if {$type=="pattern"} {
		set t PatternSurface
		if [winfo exists .cmp] _resetMap_
	}
	_state_ $seText normal
	$seText insert end "Declare unnamed$se(counter) =\nShader \[\n  $t \[\n  \]\n\]\n"
	_state_ $seText disabled
	lappend se(currList) $newName
	wm title . "$gui(appTitle) - Editing unnamed$se(counter)"
	# set se(currShFilePath) $outputFile(dir)/shaders/shaders0.vs
	set se(currShName) $newName
	incr se(counter)
	set se(scope) $type
	_packOptions_ $type
	_currentShMenu_
	_saveCurrentDef_
	.f2.sn config -state normal
	file copy -force icons/nr.png $tmpDir/Vse_$se(currShName).png
}

proc _currentShMenu_ {} {
	global se
	.mainM.m2 delete 0 end
	foreach i [lsort $se(currList)] {
		.mainM.m2 add command -label $i -command "_setCurrentShader_ $i"
	}
}

proc _renameCurrentSh_ {} {
	global seText se gui tmpDir
	if {$se(currShName)==""} {
		set sn [lindex [$seText get 1.0 end] 1]
		if {$sn!=""} {set se(currShName) $sn}
		return
	}
	set currSrc [lsearch $se(currList) $se(currShName)]
	set oldShName [lindex [$seText get 1.0 1.end] 1]
	if {$currSrc!=-1&&$oldShName!="$se(currShName)"} {
		tk_messageBox -message "Name already exists in editing list" -parent .
		set se(currShName) $oldShName
		return
	}
	if {$oldShName=="$se(currShName)"} return
	set oldSrc [lsearch $se(currList) $oldShName]
	set se(currShName) [join $se(currShName) _]
	if {$se(currShName)==""} {set se(currShName) $oldShName}
	_state_ $seText normal
	$seText delete 1.0 1.end
	$seText insert 1.0 "Declare $se(currShName) ="
	_state_ $seText disabled
	wm title . "$gui(appTitle) - Editing $se(currShName)"
	set oldSrc [lsearch $se(currList) $oldShName]
	if {$oldSrc==-1} {tk_messageBox -message "Error in rename shader"; return}
	set se(currList) [lreplace $se(currList) $oldSrc $oldSrc $se(currShName)]
	global $oldShName $oldShName.path $se(currShName)
	unset $oldShName
	unset $oldShName.path
	global $se(currShName) $se(currShName).path
	_saveCurrentDef_
	_currentShMenu_
	set thumbf1 $tmpDir/Vse_$oldShName.png
	set thumbf2 $tmpDir/Vse_$oldShName.tga
	set thumbf1a $tmpDir/Vse_$se(currShName).png
	set thumbf2a $tmpDir/Vse_$se(currShName).tga
	if [file exists $thumbf1] {file rename $thumbf1 $thumbf1a}
	if [file exists $thumbf2] {file rename $thumbf2 $thumbf2a}
}

proc _saveCurrentDef_ {} {
	# 
	# Salva in una variabile con nome 'nome_shader' il contenuto di seText
	# es.: set unnamed1 "Declare ..."
	# ed una variabile 'nome_shader.path' con il path completo del file archivio
	# es.: set unnamed1.path "C:/.../shaders.vs"
	# 
	global se seText
	if {$se(currShName)==""} return
	global $se(currShName) $se(currShName).path
	# 
	# Nel caso si abbia scritto inavvertitamente nella entry senza confermare
	# il rename:
	# 
	set se(currShName) [lindex [$seText get 1.0 1.end] 1]
	set $se(currShName) [$seText get 1.0 "end -1l"]
	set $se(currShName).path $se(currShFilePath)
}

proc _setCurrentShader_ {name} {
	global seText $name se gui tmpDir
	if {$se(currShName)=="$name"} {
		_showCurrThumb_
		return
	}
	_saveCurrentDef_
	_resetCurrentShader_
	_state_ $seText normal
	$seText insert end [set $name]
	_state_ $seText disabled
	set se(currShName) $name
	global $se(currShName).path
	set se(currShFilePath) [set $se(currShName).path]
	set se(currShFileName) [file tail $se(currShFilePath)]
	set plSrc [$seText search PlainSurface 1.0]
	set paSrc [$seText search PatternSurface 1.0]
	if {$plSrc!=""} {
		set se(scope) plain
		_packOptions_ plain
	}
	if {$paSrc!=""} {
		set se(scope) pattern
		_packOptions_ pattern
	}
	wm title . "$gui(appTitle) - Editing $name"
	_showCurrThumb_
	_readCurrentDef_
}

proc _showCurrThumb_ {} {
	global tmpDir se
	set thumbfTmp $tmpDir/Vse_$se(currShName).png
	if [file exists $thumbfTmp] {
		set im [image create photo -file $thumbfTmp]
		.f2.r.im config -image $im
	} else {
		tk_messageBox -icon error -parent . -title "" -type ok \
			-message "Error in loading thumbnail"
	}
}

proc _rgbReadValue_ {i arr bt} {
	# Il valore rgb e' sempre a fondo linea, tipo: "... '0.500,0.500,0.500'"
	global seText $arr
	set l [$seText get $i "$i lineend"]
	set rgb [split [string trim [lindex $l end] '] ,]
	set [set arr](red) [lindex $rgb 0]
	set [set arr](green) [lindex $rgb 1]
	set [set arr](blue) [lindex $rgb 2]
	$bt config -bg [eval _exaColor_ "[lindex $rgb 0] [lindex $rgb 1] [lindex $rgb 2]"]
}

proc _rgbReadValue2_ {rgb arr bt} {
	# Arriva rgb: "0.500,0.500,0.500"
	global seText $arr
	set rgb [split $rgb ,]
	set [set arr](red) [lindex $rgb 0]
	set [set arr](green) [lindex $rgb 1]
	set [set arr](blue) [lindex $rgb 2]
	$bt config -bg [eval _exaColor_ "[lindex $rgb 0] [lindex $rgb 1] [lindex $rgb 2]"]
}

proc _clearTmpDir_ {shName} {
	global tmpDir
	foreach f [glob -nocomplain $tmpDir/Vse_$shName.*] {file delete -force $f}
}

proc _clearTmpDirAll_ {} {
	global tmpDir
	foreach f [glob -nocomplain $tmpDir/Vse_*] {file delete -force $f}
}

proc _about_ {} {
	tk_messageBox -icon info -parent . -title "Vse" -type ok \
		-message "Vse - VirtuaLight Shader Editor\n\nWritten in TclTk by Gigi Giorgi\n\
			http://digilander.iol.it/3dwin\ngigi.giorgi@ciaoweb.it\n\n\
			May, 29 2003"
}
