proc _listMapsInMenu_ {filePath} {
	global se
	.cmp.m3 delete 0 end
	if ![file exists $filePath] return
	set f [open $filePath r]
	.cmp.m3 add command -label $se(currMpFileName) -state disabled
	.cmp.m3 add separator
	while {[gets $f line]>=0} {
		if [string match "Declare * = SpectrumOfColors (" $line] {
			set mname [lindex $line 1]
			.cmp.m3 add command -label $mname -command "_loadCmap_ $filePath $mname"
		}
	}
	close $f
}

proc _saveSingleShader_ {} {
	global se seText
	if {$se(currShName)==""} return
	_saveCurrentDef_
	_saveShader_ $se(currShName) $se(currShFilePath)
}

proc _saveAll_ {} {
	global se seText
	if {$se(currShName)==""} return
	_saveCurrentDef_
	set saved "Saved"
	foreach s [lsort $se(currList)] {
		global $s
		global [set $s] $s.path
		set p [set $s.path]
		_saveShader_ $s $p
		lappend saved "\n$s ($p)"
	}
	tk_messageBox -message [join $saved] -parent . -title "Multiple save"
}

proc _saveShader_ {seCurrShName seCurrShFilePath} {
	global se tmpDir seText $seCurrShName
	set csf $seCurrShFilePath
	if ![file exists $csf] {
		set cf [open $csf w]
		puts $cf [set $seCurrShName]
		close $cf
		_saveThumbNail_ $seCurrShName $csf
		return
	}
	set replaced 0
	set tmpfn $tmpDir/Vse_Archive.vs
	set tmpf [open $tmpfn w]
	set cf [open $csf r]
	while {[gets $cf line]>=0} {
		if [string match "Declare $seCurrShName =" $line] {
			puts -nonewline $tmpf [set $seCurrShName]
			while {$line!=""} {gets $cf line}
			set replaced 1
		}
		puts $tmpf $line
	}
	if {$replaced==0} {puts $tmpf [set $seCurrShName]}
	close $tmpf
	close $cf
	if [file exists $csf] {file delete $csf}
	file copy $tmpfn $csf
	_saveThumbNail_ $seCurrShName $csf
}

proc _saveThumbNail_ {seCurrShName seCurrShFilePath} {
	global tmpDir
	set fn [file rootname [file tail $seCurrShFilePath]]
	set td [file dirname $seCurrShFilePath]/vseTns/$fn
	file mkdir $td
	set tf $tmpDir/Vse_$seCurrShName.png
	if [file exists $tf] {file copy -force $tf $td/$seCurrShName.png}
}

proc _copyCurrent_ {} {
	global seText se gui tmpDir
	if {$se(currShName)==""} return
	_saveCurrentDef_
	file copy -force $tmpDir/Vse_$se(currShName).png $tmpDir/Vse_$se(currShName)_c.png
	set se(currShName) $se(currShName)_c
	_state_ $seText normal
	$seText delete 1.0 1.end
	$seText insert 1.0 "Declare $se(currShName) ="
	_state_ $seText disabled
	lappend se(currList) $se(currShName)
	wm title . "$gui(appTitle) - Editing $se(currShName)"
	_currentShMenu_
	_saveCurrentDef_
}

proc _closeAll_ {} {
	global se
	if {$se(currShName)==""} return
	foreach s [lsort $se(currList)] {
		_setCurrentShader_ $s
		_closeCurrent_
	}
}

proc _closeCurrent_ {} {
	global seText se gui tmpDir
	if {$se(currShName)==""} return
	global $se(currShName) $se(currShName).path
	unset $se(currShName)
	unset $se(currShName).path
	set oldSrc [lsearch $se(currList) $se(currShName)]
	if {$oldSrc==-1} {tk_messageBox -message "Error in closing shader"; return}
	set se(currList) [lreplace $se(currList) $oldSrc $oldSrc]
	_currentShMenu_
	_clearTmpDir_ $se(currShName)
	_resetCurrentShader_
	if {[llength $se(currList)]>0} {
		set sn [lindex $se(currList) end]
		_setCurrentShader_ $sn
		wm title . "$gui(appTitle) - Editing $sn"
	} else {
		wm title . "$gui(appTitle)"
		set se(currShName) {}
		.f2.sn config -state disabled
	}
}


proc _loadShaderWin_ {} {
	global se lbShNames
	toplevel .lsh
	wm geometry .lsh +[expr [winfo x .]+10]+[expr [winfo y .]+10]
	wm transient .lsh .
	wm title .lsh "Load shader"
	wm resizable .lsh 0 0
	bind .lsh <Escape> {destroy .lsh; grab .}
	frame .lsh.f1 -relief ridge -bd 2; # archive file
	label .lsh.f1.lb -text $se(tmpShFileName) -textvar se(tmpShFileName)
	button .lsh.f1.b -image $se(opIm) -command {
		global se lbShNames
		_setShFile_ Open
		_listAvShaders_ $se(tmpShFilePath) $lbShNames
	}
	pack .lsh.f1 -fill x
	pack .lsh.f1.lb -side left -anchor w
	pack .lsh.f1.b -side right -fill y -anchor e
	frame .lsh.f2
	frame .lsh.f2.lf; # listbox and scrollbar
	set lbShNames [listbox .lsh.f2.lf.l -width 30 -yscrollcommand {.lsh.f2.lf.s set} \
		-selectmode browse -exportselection false -foreground yellow \
		-background grey45 -selectbackground grey55 -selectforeground white]
	_bindEnterLeave_ $lbShNames se(infoText) \
		"Select a shader and press the icon button"
	bind $lbShNames <ButtonRelease-1> {
		global se lbShNames
		_showLoadShThumbnail_ $se(tmpShFileName) $se(tmpShFilePath) \
			$lbShNames .lsh.f2.im
	}
	scrollbar .lsh.f2.lf.s -command {.lsh.f2.lf.l yview} -orient vert
	pack .lsh.f2 -fill both
	pack $lbShNames -side left -fill both -expand 1
	pack .lsh.f2.lf.s -side right -fill y
	button .lsh.f2.im -image $se(esIm) -command {
		global se
		set s [.lsh.f2.lf.l curselection]
		if {$s==""} return
		set shname [.lsh.f2.lf.l get $s]
		_loadShader_ $se(tmpShFilePath) $shname
	}
	pack .lsh.f2.lf .lsh.f2.im -side left
	_listAvShaders_ $se(tmpShFilePath) $lbShNames
	grab .lsh
}

proc _showLoadShThumbnail_ {fname fpath lbox w} {
	global lbShNames se
	set s [$lbox curselection]
	if {$s==""} return
	set shname [$lbox get $s]
	set fn [file rootname $fname]
	# vai a cercare il thumbnail e visualizzalo nel button:
	set tf [file dirname $fpath]/vseTns/$fn/$shname.png
	set im $se(seIm)
	if [file exists $tf] {set im [image create photo -file $tf]}
	$w config -image $im
}

proc _listAvShaders_ {sfile lbox} {
	$lbox delete 0 end
	set f [open $sfile r]
	while {[gets $f line]>=0} {
		if [string match {Declare * =*} $line] {
			$lbox insert end [lindex $line 1]
		}
	}
	close $f
}

proc _loadShader_ {filePath shname} {
	global se gui seText lbShNames tmpDir
	if [winfo exists .lsh] {set par .lsh} else {set par .}
	if ![file exists $filePath] {
		tk_messageBox -icon info -parent $par -title "" -type ok \
			-message "$filePath doesn't exists"
		return
	}
	if {[lsearch $se(currList) $shname]!=-1} {
		set answer [tk_messageBox -icon question -parent $par -title "Replace shader" \
			-type yesno -message "Shader '$shname' already loaded.\n\
				Do you want to replace it ?"]
		switch -- $answer {
    		yes {
    			_setCurrentShader_ $shname
				_closeCurrent_
			}
    		no  {destroy .lsh; return}
		}
	}
	_saveCurrentDef_
	_resetCurrentShader_
	set f [open $filePath r]
	set shExists 0
	while {[gets $f line]>=0} {
		if [string match "Declare $shname =" $line] {
			set shExists 1
			_state_ $seText normal
			$seText insert end $line
			while {$line!=""} {
				gets $f line
				if [string match {  PlainSurface \[} $line]   {set type plain}
				if [string match {  PatternSurface \[} $line] {set type pattern}
				$seText insert end \n$line
			}
			_state_ $seText disabled
		}
	}
	close $f
	if {$shExists==0} {
		tk_messageBox -icon error -parent $par -title "Error" -type ok \
			-message "Shader '$shname' not in\n$filePath"
		return
	}
 	lappend se(currList) $shname
	wm title . "$gui(appTitle) - Editing $shname"
	set se(currShName) $shname
	set se(currShFilePath) $filePath
	set se(currShFileName) [file tail $se(currShFilePath)]
	set se(scope) $type
	_packOptions_ $type
	_currentShMenu_
	_saveCurrentDef_
	_readCurrentDef_
	set fn [file rootname $se(currShFileName)]
	set thumbfSvd [file dirname $se(currShFilePath)]/vseTns/$fn/$se(currShName).png
	if [file exists $thumbfSvd] {
		set tnf $thumbfSvd
	} else {
		set tnf icons/nr.png
	}
	file copy -force $tnf $tmpDir/Vse_$se(currShName).png
	.f2.r.im config -image [image create photo -file $tnf]
	.f2.sn config -state normal
	destroy .lsh
}
