######################################################################################
# option add
######################################################################################
option add *font $gui(defFont)
option add *Checkbutton.borderWidth 0
option add *Checkbutton.disabledForeground black
option add *Checkbutton.padY 0
option add *Frame.borderWidth 0
option add *Button.borderWidth 1
option add *Button.padY 0
option add *Entry.borderWidth 1
option add *Entry.justify c
option add *Entry.background "grey90"
option add *Label.borderWidth 1.2
option add *Listbox.selectBackground "grey85"
option add *Listbox.selectForeground "black"
option add *Listbox.selectBorderWidth 0
option add *Listbox.borderWidth 1
option add *Text.cursor "left_ptr"
option add *Text.borderWidth 1
option add *Menu.disabledForeground "grey50"
option add *Menu.borderWidth 1
option add *Scale.borderWidth 1
option add *Scale.highlightThickness 0

######################################################################################
# Icone
######################################################################################
set se(opIm) [image create photo -file icons/open.png]
set se(rfIm) [image create photo -file icons/refresh.png]
set se(svIm) [image create photo -file icons/save.png]
set se(seIm) [image create photo -file icons/nr.png]; # 150x150
set se(esIm) [image create photo -file icons/es.png]; # 150x150 scena vuota
set se(nwIm) [image create photo -file icons/new.png]
set se(ldIm) [image create photo -file icons/load.png]
set se(clIm) [image create photo -file icons/close.png]
set se(clrIm) [image create photo -file icons/close_rid.png]
set se(mgIm) [image create photo -file icons/mngt.png]
set se(apIm) [image create photo -file icons/apply.png]
set se(upIm) [image create photo -file icons/up.png]
set se(dwIm) [image create photo -file icons/down.png]
set se(rgIm) [image create photo -file icons/right.png]
set se(lfIm) [image create photo -file icons/left.png]

##################################################################################
# Bindings
##################################################################################
# Commentare la linea che segue:
#bind . <Control-x> {destroy .; exec wish Vse.tcl &}
bind . <Control-s> _saveSingleShader_
bind . <Control-S> _saveAll_
bind . <Control-c> _copyCurrent_
bind . <Control-w> _closeCurrent_
bind . <Control-W> _closeAll_
bind . <Control-l> _loadShaderWin_
bind . <Control-L> _libraryWin_
bind . <Control-q> _exit_
bind Entry <ButtonRelease-3> {focus %W; %W selection range 0 end}
. config -menu .mainM

##################################################################################
# Main Toolbar Menu
##################################################################################
menu .mainM
.mainM add cascade -label "Shader" -menu .mainM.m1
.mainM add cascade -label "Current" -menu .mainM.m2
.mainM add cascade -label "Help" -menu .mainM.m3
menu .mainM.m1 -tearoff 0
.mainM.m1 add cascade -label "New" -menu .mainM.m1.m
.mainM.m1 add command -label "Load ..." -acc <Ctrl-l>      -command _loadShaderWin_
.mainM.m1 add command -label "Save current" -acc <Ctrl-s>  -command _saveSingleShader_
.mainM.m1 add command -label "Save all" -acc <Ctrl-S>      -command _saveAll_
.mainM.m1 add command -label "Copy current" -acc <Ctrl-c>  -command _copyCurrent_
.mainM.m1 add separator
.mainM.m1 add command -label "Close current" -acc <Ctrl-w> -command _closeCurrent_
.mainM.m1 add command -label "Close all" -acc <Ctrl-W>     -command _closeAll_
.mainM.m1 add command -label "Reset current"               -command _clearCurrentShader_
.mainM.m1 add separator
.mainM.m1 add command -label "Library ..." -acc <Ctrl-L>   -command _libraryWin_
.mainM.m1 add command -label "Setup ..."                   -command _setupWin_
.mainM.m1 add separator
.mainM.m1 add cascade -label "Workspace" -menu .mainM.m1.m1
.mainM.m1 add separator
.mainM.m1 add command -label "Exit ..." -acc <Ctrl-q>      -command _exit_
menu .mainM.m1.m -tearoff 0
menu .mainM.m1.m1 -tearoff 0
.mainM.m1.m1 add command -label "Save ..."            -command _saveWorkspace_
.mainM.m1.m1 add command -label "Load ..."            -command {_loadWorkspace_ ""}
.mainM.m1.m1 add command -label "Close"               -command _closeAll_
.mainM.m1.m add command -label "Plain"                -command {_newShader_ plain}
.mainM.m1.m add command -label "Pattern"              -command {_newShader_ pattern}
.mainM.m1.m add command -label "Functional"  -state disabled
.mainM.m1.m add separator
.mainM.m1.m add command -label "Multi-layer" -state disabled
.mainM.m1.m add command -label "Composite"   -state disabled
.mainM.m1.m add command -label "Indexed"     -state disabled
menu .mainM.m2 -tearoff 0
menu .mainM.m3 -tearoff 0
.mainM.m3 add command -label "About" -command _about_

##################################################################################
# Menus
##################################################################################
menu .lgt -tearoff 0
.lgt add checkbutton -label "Upper left light" -var se(lsa)
.lgt add checkbutton -label "Lower left light" -var se(lsb)
.lgt add checkbutton -label "Upper right light" -var se(lda)
.lgt add checkbutton -label "Lower righ light" -var se(ldb)

##################################################################################
# Frame .f1 di sinistra (opzioni)
##################################################################################
frame .f1 -relief sunken -bd 2
pack .f1 -side left -fill both
frame .f1.d -relief ridge -bd 2; # archive file dir
label .f1.d.lb -text "$se(currShFileName)" -textvar se(currShFileName)
_bindEnterLeave_ .f1.d.lb se(infoText) "Current shaders archive file"
button .f1.d.b -image $se(opIm) -command {_setShFile_ Open}
_bindEnterLeave_ .f1.d.b se(infoText) "Set current shaders file"
button .f1.d.n -image $se(nwIm) -command {_setShFile_ Save}
_bindEnterLeave_ .f1.d.n se(infoText) "Create new shaders file"
pack .f1.d -fill x -padx 2 -pady 2
pack .f1.d.lb -side left -anchor w
pack .f1.d.n .f1.d.b -side right -fill y -anchor e
# 
# Common options:
# 
frame .f1.o1
pack .f1.o1
frame .f1.o1.1
frame .f1.o1.2
pack .f1.o1.1 .f1.o1.2 -side left -anchor n
_insertOptFrame_ .f1.o1.1.df "Diffuse"
_insertCbLbScale_ .f1.o1.1.df.a 6 amount plSur(dfsAOn) plSur(dfsAVal) 0 1 0.001 \
	{_updateText_ dfsAOn}
_insertCbLbColor_ .f1.o1.1.df.c . 6 "body color" plSur(dfsCOn) plSurDfsColor \
	{_updateText_ dfsCOn}
_insertCbLbEn_ .f1.o1.1.df.b 6 brilliance plSur(dfsBOn) plSur(dfsBVal) \
	{_updateText_ dfsBOn}
bind .f1.o1.1.df.b.en1 <Any-KeyRelease> {_updateText_ dfsBOn}
_insertOptFrame_ .f1.o1.1.am "Ambient"
_insertCbLbScale_ .f1.o1.1.am.a 6 amount plSur(ambAOn) plSur(ambAVal) 0 1 0.001 \
	{_updateText_ ambAOn}
_insertCbLbColor_ .f1.o1.1.am.c . 6 color plSur(ambCOn) plSurAmbColor \
	{_updateText_ ambCOn}
_insertOptFrame_ .f1.o1.1.sh "Specular highlights"
_insertCbLbScale_ .f1.o1.1.sh.b 6 brightness plSur(sphBOn) plSur(sphBVal) \
	0.0 1.0 0.001 {_updateText_ sphBOn}
_insertCbLbColor_ .f1.o1.1.sh.c . 6 color plSur(sphCOn) plSurSphColor \
	{_updateText_ sphCOn}
_insertCbLbMenu_ .f1.o1.1.sh.d1 8 "BRDF" "Phong Blinn Cook Reitz Gaussian" \
	"" plSur(sphDOn) plSur(sphDVal) \
	{_updateText_ sphDOn}
_insertCbLbScale_ .f1.o1.1.sh.d2 6 "angle" {} plSur(sphDaVal) 0 45 1 \
	{_updateText_ sphDOn}
_insertOptFrame_ .f1.o1.1.sr "Specular reflection"
_insertCbLbScale_ .f1.o1.1.sr.a 6 amount plSur(sprAOn) plSur(sprAVal) 0 1 0.001 \
	{_updateText_ sprAOn}
_insertCbLbScale_ .f1.o1.1.sr.b 6 blur plSur(sprBOn) plSur(sprBVal) 0 1 0.001 \
	{_updateText_ sprBOn}
_insertCbLbEn_ .f1.o1.1.sr.m 6 metal plSur(sprMOn) plSur(sprMVal) \
	{_updateText_ sprMOn}
bind .f1.o1.1.sr.m.en1 <Any-KeyRelease> {_updateText_ sprMOn}
_insertCbLbColor_ .f1.o1.1.sr.c . 6 color plSur(sprCOn) plSurSprColor \
	{_updateText_ sprCOn}
_insertOptFrame_ .f1.o1.2.st "Specular transmission     "
_insertCbLbScale_ .f1.o1.2.st.a 6 amount plSur(sptAOn) plSur(sptAVal) 0 1 0.001 \
	{_updateText_ sptAOn}
_insertCbLbScale_ .f1.o1.2.st.i 6 ior plSur(sptIOn) plSur(sptIVal) \
	1.003 3.34 0.001 {_updateText_ sptIOn}
_insertCbLbColor_ .f1.o1.2.st.c . 6 color plSur(sptCOn) plSurSptColor \
	{_updateText_ sptCOn}
_insertCbLbScale_ .f1.o1.2.st.b 6 blur plSur(sptBOn) plSur(sptBVal) 0.0 1.0 0.001 \
	{_updateText_ sptBOn}
_insertOptFrame_ .f1.o1.2.ca "Caustics"
_insertCbLbScale_ .f1.o1.2.ca.a 6 amount plSur(cauAOn) plSur(cauAVal) 0 1 0.001 \
	{_updateText_ cauAOn}
checkbutton .f1.o1.2.ca.i -text internal -var plSur(cauIOn) -comm \
	{_updateText_ cauIOn}
pack .f1.o1.2.ca.i -anchor w
_insertOptFrameCb_ .f1.o1.2.ir "Iridescence" plSur(iridOn)
.f1.o1.2.ir.f.cb config -command {_updateText_ iridOn}
_insertCbLbScale_ .f1.o1.2.ir.a 6 amount {} plSur(iriAVal) \
	0.0 1.0 0.001 {_updateText_ iridOn}
_insertCbLbScale_ .f1.o1.2.ir.h 6 thickness {} plSur(iriFVal) \
	0.0 1.0 0.001 {_updateText_ iridOn}
_insertCbLbScale_ .f1.o1.2.ir.t 6 turbulence {} plSur(iriTVal) \
	0.1 2.0 0.001 {_updateText_ iridOn}
_insertCbLbColor_ .f1.o1.2.ir.c . 6 color plSur(iriCOn) plSurIriColor \
	{_updateText_ iriCOn}
_insertOptFrame_ .f1.o1.2.is "Irradiance samples"
_insertCbLbEn_ .f1.o1.2.is.a 6 amount plSur(irsAOn) plSur(irsAVal) \
	{_updateText_ irsAOn}
bind .f1.o1.2.is.a.en1 <Any-KeyRelease> {_updateText_ irsAOn}
# 
# Pattern surface options:
# 
frame .f1.o2
pack .f1.o2 -fill x -padx 4 -pady 2
_insertSeparator_ .f1.o2.sep
frame .f1.o2.1
frame .f1.o2.2
pack .f1.o2.1 .f1.o2.2 -side left -anchor n -fill both -expand 1
_insertOptFrame_ .f1.o2.1.cm ""
_insertCbLbBt_ .f1.o2.1.cm.sc 6 "S.o.c." paSur(cmapOn) \
	{_updateText_ cmapOn} _cMapWin_
_insertOptFrameCb_ .f1.o2.1.pm "Pattern modifiers" paSur(ptModOn)
.f1.o2.1.pm.f.cb config -command {_updateText_ ptModOn}
_insertLbMenu_ .f1.o2.1.pm.fu 8 4 " function" "0 1 2 3 4 5 6" \
	"Natural Sine Cosine Catmull-Rom {1-D lattice} Ramp Sawtooth" \
	{_updateText_ ptModOn} paSur(funVal)
_insertLbMenu_ .f1.o2.1.pm.in 10 4 " inters. mode" "0 1 2 3 4 5 6 7 8 9" \
	"{No turbulence} {Turb. based on var Po\[x\]} {Turb. based on var Po\[y\]} \
	{Turb. based on var Po\[z\]} {Turb. based on var P\[y\]} \
	{Turb. based on var P\[z\]} {Turb. based on var P\[z\]} {Spherical turbulence}\
	{Cylindrical turbolence} {Radial turbolence}" {_updateText_ ptModOn} \
	paSur(intVal)
_insertLbMenu_ .f1.o2.1.pm.nm 10 4 " norm. mode" "0 1 2 3 4" "{No perturbation}\
	Bumps Dents Wrinkles {Waves and ripples}" {_updateText_ ptModOn} \
	paSur(norVal)
_insertCbLbEn_ .f1.o2.1.pm.ps 6 "scale" paSur(sclOn) paSur(sclVal) \
	{_updateText_ sclOn}
bind .f1.o2.1.pm.ps.en1 <Any-KeyRelease> {_updateText_ sclOn}
_insertOptFrame_ .f1.o2.2.to ""
_insertCbLbEn_ .f1.o2.2.to.tr 6 "turbulence" paSur(turOn) paSur(turVal) \
	{_updateText_ turOn}
bind .f1.o2.2.to.tr.en1 <Any-KeyRelease> {_updateText_ turOn}
_insertCbLbEn_ .f1.o2.2.to.oc 6 "octaves" paSur(octOn) paSur(octVal) \
	{_updateText_ octOn}
bind .f1.o2.2.to.oc.en1 <Any-KeyRelease> {_updateText_ octOn}
_insertOptFrameCb_ .f1.o2.2.bp "Bumpiness" paSur(bmpOn)
.f1.o2.2.bp.f.cb config -command {_updateText_ bmpOn}
_insertLbEn_ .f1.o2.2.bp.ba 10 6 amplitude paSur(bmaVal)
bind .f1.o2.2.bp.ba.en <Any-KeyRelease> {_updateText_ bmpOn}
_insertLbEn_ .f1.o2.2.bp.bf 10 6 frequency paSur(bmfVal)
bind .f1.o2.2.bp.bf.en <Any-KeyRelease> {_updateText_ bmpOn}
_insertCbLbEn_ .f1.o2.2.bp.ph 6 phase paSur(phaOn) paSur(phaVal) \
	{_updateText_ phaOn}
bind .f1.o2.2.bp.ph.en1 <Any-KeyRelease> {_updateText_ phaOn}

##################################################################################
# Frame .f2 di destra (rendering e txt)
##################################################################################
frame .f2 -relief sunken -bd 2
pack .f2 -side right -fill both -expand 1
entry .f2.sn -textvariable se(currShName) -state disabled
bind .f2.sn <Key-Return> _renameCurrentSh_
pack .f2.sn -fill x -padx 2 -pady 2
_bindEnterLeave_ .f2.sn se(infoText) "Current shader (Return to rename)"
# 
# Rendering
# 
frame .f2.r; # rendering
pack .f2.r -fill both
label .f2.r.im -relief sunken -image $se(seIm); # 150x150
bind .f2.r.im <ButtonRelease-3> "tk_popup .lgt %X %Y"
bind .f2.r.im <ButtonRelease-1> _sceneOptionsWin_
pack .f2.r.im -side left -padx 3 -pady 3
frame .f2.r.o -relief sunken -bd 1 ; # opzioni di rendering
pack .f2.r.o -fill both -padx 3 -pady 3
		#checkbutton .f2.r.o.cb1 -text "Floor" -var se(floorOn)
		#checkbutton .f2.r.o.cb2 -text "Wall" -var se(wallOn)
		#pack .f2.r.o.cb2 .f2.r.o.cb1 -anchor w
		#_insertLbMenu_ .f2.r.o.pri 10 8 " Object" \
		#	"Cylinder Sphere Torus Box Disc" "" {} se(prim)
		#_insertCbLbColor_ .f2.r.o.bgr . 8 "Background" {} se n
button .f2.r.o.lb -bd 1 -text "Log" -command _viewRenderLog_
button .f2.r.o.ra -bd 1 -text "ReadArchive ..." -command _readArchiveWin_
button .f2.r.o.rn -bd 1 -text "Render" -fg blue -command _shRender_
button .f2.r.o.ro -bd 1 -text "Render options ..." -command _sceneOptionsWin_
pack .f2.r.o.ra .f2.r.o.ro .f2.r.o.rn .f2.r.o.lb -fill x -anchor s
# 
# Text
# 
frame .f2.t; # text
pack .f2.t -fill both -expand 1
_insertText_ .f2.t.t 40 10 grey45 white $gui(textFont) seText
_state_ $seText disabled
# 
# Transformations
# 
frame .f2.tr
entry .f2.tr.s -width 2
entry .f2.tr.r -width 2
button .f2.tr.cl1 -image $se(clrIm) -command {
	.f2.tr.s delete 0 end; _applyTransf_ Scale .f2.tr.s
}
_bindEnterLeave_ .f2.tr.cl1 se(infoText) "Remove transformation"
button .f2.tr.cl2 -image $se(clrIm) -command {
	.f2.tr.r delete 0 end; _applyTransf_ Rotate .f2.tr.r
}
_bindEnterLeave_ .f2.tr.cl2 se(infoText) "Remove transformation"
bind .f2.tr.s <Key-Return> {_applyTransf_ Scale .f2.tr.s}
bind .f2.tr.r <Key-Return> {_applyTransf_ Rotate .f2.tr.r}
_bindEnterLeave_ .f2.tr.s se(infoText) "Rotate (x y z, Return to apply)"
_bindEnterLeave_ .f2.tr.r se(infoText) "Scale (x y z, Return to apply)"
pack .f2.tr -fill x -padx 2 -pady 2
pack .f2.tr.s -side left -fill both -expand 1
pack .f2.tr.cl1 -side left
pack .f2.tr.r -side left -fill both -expand 1
pack .f2.tr.cl2 -side left
# 
# Label di info
# 
label .f2.info -relief sunken -fg blue -textvar se(infoText)
pack .f2.info -fill x -padx 2 -pady 2

