proc _readArchiveWin_ {} {
	if [winfo exists .ra] return
	global se
	toplevel .ra
	wm geometry .ra +[winfo pointerx .]+[winfo pointery .]
	wm transient .ra .
	wm title .ra "ReadArchive setup"
	wm resizable .ra 0 0
	set se(RAlbox) [_insertLbox_ .ra.l 16 {}]
	_insertUpDownDel_ .ra.sl $se(RAlbox)
	_bindEnterLeave_ .ra.sl.up se(infoText) "Move selected up"
	_bindEnterLeave_ .ra.sl.dw se(infoText) "Move selected down"
	_bindEnterLeave_ .ra.sl.dl se(infoText) "Remove selected"
	entry .ra.e
	_bindEnterLeave_ .ra.e se(infoText) "Type a file name and hit Return to add"
	bind .ra.e <Key-Return> {
		global se
		set n [join [.ra.e get] _]
		if {$n==""} break
		$se(RAlbox) insert end $n
		.ra.e delete 0 end
		.ra.e insert end $n
	}
	pack .ra.e -fill x
	_insertApplyDismiss_ .ra.ok Apply .ra . {
		global se
		set se(RAlist) [$se(RAlbox) get 0 end]
		destroy .ra
	}
	foreach f $se(RAlist) {$se(RAlbox) insert end $f}
}

proc _libraryWin_ {} {
	global se
	toplevel .lw
	wm geometry .lw +[winfo pointerx .]+[winfo pointery .]
	wm transient .lw .
	wm title .lw "Shaders manager"
	wm resizable .lw 0 0
	bind .lw <Escape> {destroy .lw; grab .}
	frame .lw.f
	pack .lw.f
	frame .lw.f.f1
	frame .lw.f.f2
	pack .lw.f.f1 .lw.f.f2 -side left -fill both -expand 1
	frame .lw.f.f1.f -relief ridge -bd 2; # archive file 1
	label .lw.f.f1.f.lb -text $se(libFile1) -textvariable se(libFile1)
	button .lw.f.f1.f.b -image $se(opIm) -command "_setLibFile_ 1"
	_bindEnterLeave_ .lw.f.f1.f.b se(infoText) "RighMB: clear"
	bind .lw.f.f1.f.b <ButtonRelease-3> {
		.lw.m2 entryconfigure 0 -command {_clearLibLbox_ 1}
		tk_popup .lw.m2 %X %Y
	}
	frame .lw.f.f2.f -relief ridge -bd 2; # archive file 1
	label .lw.f.f2.f.lb -text $se(libFile2) -textvariable se(libFile2)
	button .lw.f.f2.f.b -image $se(opIm) -command "_setLibFile_ 2"
	_bindEnterLeave_ .lw.f.f2.f.b se(infoText) "RightMB: clear"
	bind .lw.f.f2.f.b <ButtonRelease-3> {
		.lw.m2 entryconfigure 0 -command {_clearLibLbox_ 2}
		tk_popup .lw.m2 %X %Y
	}
	pack .lw.f.f1.f .lw.f.f2.f -fill x
	pack .lw.f.f1.f.lb .lw.f.f2.f.lb -side left -anchor w
	pack .lw.f.f1.f.b .lw.f.f2.f.b -side right -fill y -anchor e
	set se(SLlbox1) [_insertLbox_ .lw.f.f1.l 16 {}]
	set se(SLlbox2) [_insertLbox_ .lw.f.f2.l 16 {}]
	bind $se(SLlbox1) <ButtonRelease-1> {_bindLibRel1_ 1}
	bind $se(SLlbox1) <ButtonRelease-3> {_bindLibRel3_ 1 %y %X %Y}
	bind $se(SLlbox2) <ButtonRelease-1> {_bindLibRel1_ 2}
	bind $se(SLlbox2) <ButtonRelease-3> {_bindLibRel3_ 2 %y %X %Y}
	_insertUpDownDelSide_ r .lw.f.f1.sl $se(SLlbox1) $se(SLlbox2) 1
	_insertUpDownDelSide_ l .lw.f.f2.sl $se(SLlbox2) $se(SLlbox1) 2
	_bindEnterLeave_ .lw.f.f1.sl se(infoText) "Move or delete (X) selected"
	_bindEnterLeave_ .lw.f.f2.sl se(infoText) "Move or delete (X) selected"
	label .lw.f.f1.im -image $se(esIm) -relief sunken
	label .lw.f.f2.im -image $se(esIm) -relief sunken
	pack .lw.f.f1.im .lw.f.f2.im -pady 3
	_insertApplyDismiss_ .lw.ok "Save" .lw . {
		_applyLibraryChanges_ 1
		_applyLibraryChanges_ 2
		destroy .lw
	}
	if {$se(libFile1)!=""} {_listLibShaders_ 1}
	if {$se(libFile2)!=""} {_listLibShaders_ 2}
	menu .lw.m -tearoff 0
	.lw.m add command -label "View"   -command _viewShader_
	.lw.m add command -label "Rename" -command _renameLibShaderWin_
	menu .lw.m2 -tearoff 0
	.lw.m2 add command -label "Clear"
	# 
	# txt da nascondere:
	# 
	set se(libTxt1) [text .lw.f.f1.t -width 2 -height 24 -wrap none]
	set se(libTxt2) [text .lw.f.f2.t -width 2 -height 24 -wrap none]
	# pack .lw.f.f1.t .lw.f.f2.t -fill x
	_loadTmpShaderContent_ $se(libPath1) 1
	_loadTmpShaderContent_ $se(libPath2) 2
	grab .lw
}

proc _listboxSeleMove_ {lbox val lbox2 n} {
	# 
	# Usata da LIBRARY Win ($n==1||2) e READARCHIVE Win ($n=={})
	# 
	global se
	set csele [$lbox curselection]
	if {$csele==""} return
	if {$n!=""} {
		if {[wm title .lw]=="S.o.c. manager"} {
			set win mWin; set tf map
		} else {
			set win sWin; set tf lib
		}
	}
	if {$n==1} {set lf $se([set tf]File2); set tw $se(libTxt2)}
	if {$n==2} {set lf $se([set tf]File1); set tw $se(libTxt1)}
	set shname [$lbox get $csele]
	if {$val=={}} {; # ----------------------------------------------------- SIDE MOVE
		set currLb2List [$lbox2 get 0 end]
		if {[lsearch $currLb2List $shname]!=-1} {
			tk_messageBox -icon info -parent .lw -title "" -type ok \
				-message "'$shname' already exists in destination file.\n\
					Please rename it first."
			return
		}
	}
	if {$n!=""} {; # ------------------------------------------------------- LIBRARY
		if {$lf==""&&$val==""} return
		_setShContentToMove_ $n $shname
		set cI [_removeShFromTxt_ $shname $n]
	}
	if {$val==0||$val=={}} {; # ---------------------------------- DELETE or SIDE MOVE
		$lbox selection clear 0 end
		$lbox delete $csele
		if {[$lbox index end]==$csele} {set csele end}
		$lbox selection set $csele
		if {$n!=""&&$win=="sWin"} {
			if {$lbox==".lw.f.f1.l.l"} {set n 1} else {set n 2}
			_bindLibRel1_ $n
			set csele [$lbox curselection]
			if {$csele==""} {.lw.f.f$n.im config -image $se(esIm)}
		}
	}
	if {$csele!=""} {set elem [$lbox get $csele]}
	if {$val=="-"} {; # ------------------------------------------------------ MOVE UP
		if {$n!=""} {_moveContentUp_ $cI $n}
		if {$csele==0} return
		$lbox selection clear 0 end
		$lbox insert [expr $csele -1] $elem
		$lbox delete [expr $csele +1]
		$lbox selection set [expr $csele -1]
	}
	if {$val=="+"} {; # ---------------------------------------------------- MOVE DOWN
		if {$n!=""} {_moveContentDown_ $cI $n}
		if {[expr [$lbox index end] -1]==$csele} return
		$lbox selection clear 0 end
		$lbox insert [expr $csele +2] $elem
		$lbox delete $csele
		$lbox selection set [expr $csele +1]
	}
	if {$val=={}} {; # ----------------------------------------------------- SIDE MOVE
		$lbox2 insert end $shname
		$tw insert end $se(shContToMove)
		set se(libChanged) 1
	}
	if {[$lbox curselection]!=""} {$lbox see $csele}
}

proc _setShContentToMove_ {n sname} {
	global se
	set t [set se(libTxt$n)]
	set i1 [$t search "Declare $sname =" 1.0]
	set i2 [$t search "Declare " "$i1 +1c" end]
	if {$i2==""} {set i2 "end -1l"}
	set se(shContToMove) [$t get $i1 $i2]
}

proc _removeShFromTxt_ {sname n} {
	global se
	set t [set se(libTxt$n)]
	set i1 [$t search "Declare $sname =" 1.0]
	set i2 [$t search "Declare " "$i1 +1c" end]
	if {$i2==""} {set i2 "end -1l"}
	$t delete $i1 $i2
	return $i1
}

proc _moveContentUp_ {i n} {
	global se
	set t [set se(libTxt$n)]
	set i1 [$t search -backwards "Declare " $i 1.0]
	if {$i1==""||$i=="1.0"} {set i1 1.0}
	$t insert $i1 $se(shContToMove)
}

proc _moveContentDown_ {i n} {
	global se
	set t [set se(libTxt$n)]
	set i1 [$t search "Declare " "$i +1c" end]
	if {$i==[expr [$t index end]-1.0]||$i1==""} {set i1 end}
	$t insert $i1 $se(shContToMove)
}

proc _setLibFile_ {n} {
	global se tmpDir
	if {$se(libChanged)==1} {
		set answer [tk_messageBox -icon question -parent .lw -title "" \
			-type yesnocancel -message "Save $se(libFile1) $se(libFile2) changes ?"]
		switch -- $answer {
			yes {_applyLibrayChanges_; _clearLibLbox_ $n}
			no {_clearLibLbox_ 1; _clearLibLbox_ 2}
			cancel return
		}
		
		set se(libChanged) 0
	}
	set types {{{Vse shader files} .vs}}
	set iniDir [file dirname [set se(libPath$n)]]
	set fname [tk_getOpenFile -filetypes $types \
			-defaultextension .vs -title "Select file" -parent .lw \
			-initialdir $iniDir \
			-initialfile [set se(libFile$n)]
		]
	if {$fname==""} return
	_clearLibLbox_ $n
	set se(libPath$n) $fname
	set se(libFile$n) [file tail $fname]
	if {$se(libPath1)=="$se(libPath2)"} {
		tk_messageBox -icon error -parent .lw -title "" -type ok \
			-message "Files are identical"
		_clearLibLbox_ $n
		return
	}
	_listLibShaders_ $n
	_loadTmpShaderContent_ $fname $n
}

proc _listLibShaders_ {n} {
	global se
	_listAvShaders_ [set se(libPath$n)] $se(SLlbox$n)
	if {[[set se(SLlbox$n)] size]==0} {.lw.f.f$n.im config -image $se(esIm)}
}

proc _loadTmpShaderContent_ {fname n} {
	if ![file exists $fname] return
	global se
	set t [set se(libTxt$n)]
	set f [open $fname r]
	set name [file rootname [file tail $fname]]
	$t delete 1.0 end
	while {[gets $f line]>=0} {
		if [string match {Declare * =} $line] {
			set shname [lindex $line 1]
			set tf [file dirname $fname]/vseTns/$name/$shname.png
			if [file exists $tf] {set fp $tf} else {set fp icons/nr.png}
			$t insert end "$line $fp\n"
		} else {
			$t insert end $line\n
		}
	}
	set all [join [$t get 1.0 end]]
	if {$all==""} {$t delete 1.0 end}; # altrimenti lascia un a capo vuoto nel txt
	close $f
}

proc _clearLibLbox_ {n} {
	global se
	.lw.f.f$n.im config -image $se(esIm)
	[set se(SLlbox$n)] delete 0 end
	[set se(libTxt$n)] delete 1.0 end
	set se(libFile$n) {}
	set se(libPath$n) [file dirname $se(libPath$n)]/NULL
}

proc _bindLibRel1_ {n} {
	global se
	set lbox [set se(SLlbox$n)]
	set s [$lbox curselection]
	if {$s==""} return
	set shname [$lbox get $s]
	set t [set se(libTxt$n)]
	set i [$t search "Declare $shname =" 1.0]
	set l [$t get $i "$i lineend"]
	set iF [lindex $l end]
	if [file exists $iF] {
		set im [image create photo -file $iF]
	} else {
		tk_messageBox -icon info -parent .lw -title "Vse error" -type ok \
			-message "Error in loading Library thumbnail"
		return
	}
	.lw.f.f$n.im config -image $im
}

proc _bindLibRel3_ {n y X Y} {
	global se
	set lb [set se(SLlbox$n)]
	$lb selection clear 0 end
	set i [$lb nearest $y]
	$lb selection set $i
	_bindLibRel1_ $n
	set name [$lb get $i]
	if {$name!=""} {tk_popup .lw.m $X $Y; set se(currLibLbox) $n}
}

proc _renameLibShaderWin_ {} {
	global se
	set n $se(currLibLbox)
	toplevel .rls
	wm geometry .rls +[winfo pointerx .]+[winfo pointery .]
	wm transient .rls .
	wm title .rls "Rename shader"
	wm resizable .rls 0 0
	bind .rls <Escape> {destroy .rls; grab .lw}
	set sname [[set se(SLlbox$n)] get [[set se(SLlbox$n)] curselection]]
	entry .rls.e
	bind .rls.e <Key-Return> "_renameLibShader_ $n $sname"
	pack .rls.e
	.rls.e insert end $sname
	grab .rls
	focus .rls.e
}

proc _renameLibShader_ {n oldName} {
	global se
	set nName [join [.rls.e get] _]
	if {$nName==""} return
	.rls.e delete 0 end; .rls.e insert end $nName
	set lb [set se(SLlbox$n)]
	set i [$lb curselection]
	set lbList [lreplace [$lb get 0 end] $i $i]
	if {[lsearch $lbList $nName]!=-1} {
		tk_messageBox -icon info -parent .rls -title "" -type ok \
			-message "'$nName' already exists in "
		return
	}
	$lb delete $i
	$lb insert $i $nName
	set t [set se(libTxt$n)]
	set i1 [$t search "Declare $oldName =" 1.0]
	$t delete "$i1 +8c" "$i1 +8c wordend"
	$t insert "$i1 +8c" $nName
	$lb selection set $i
	destroy .rls
	grab .lw
}

proc _applyLibraryChanges_ {n} {
# Salvo i contenuti di se(libTxt[n]) sovrascrivendo i files di destinazione.
# !! Ci sono 2 linee vuote al fondo del text widget
# !! ad ogni fine linea 'Declare shname =' c'e' un riferimento al thumb
	global se
	set lp [set se(libPath$n)]
	set lf [set se(libFile$n)]
	set t  [set se(libTxt$n)]
	set newTnDir [file dirname $lp]/vseTns/[file rootname $lf]
	file mkdir   [file dirname $lp]/vseTns
	file mkdir   $newTnDir
	if {$lf!=""} {
		# 
		# Spostamento di thumnails:
		# 
		set i 1.0
		while {$i>0} {
			set i [$t search "Declare " $i end]
			if {$i==""} break
			set line [$t get $i "$i lineend"]
			set thumbPath [lindex $line end]
			set sname [lindex $line 1]
			set currThumbPath $newTnDir/$sname.png
			if [file exists $thumbPath] {
				if {$thumbPath!="icons/nr.png"} {
					if {$thumbPath!="$currThumbPath"} {
						file copy -force $thumbPath $newTnDir
						file delete -force $thumbPath
			# non lo fa':
			# file delete [file dirname $thumbPath]; # la canc. solo se e' vuota
					}
				}
				set di [$t search " $thumbPath" $i]
				$t delete $di "$di lineend"
			} else {
				tk_messageBox -icon info -parent . -title "" -type ok \
					-message "Error in moving library thumbnail"
				break
			}
			set i [expr $i +0.1]
		}
		set wf [open $lp w]
		puts $wf [$t get 1.0 "end -2l"]
		close $wf
	}
	set se(libChanged) 0
}

proc _applyMapsLibraryChanges_ {n} {
# Salvo i contenuti di se(libTxt[n]) sovrascrivendo i files di destinazione.
# !! Ci sono 2 linee vuote al fondo del text widget
	global se
	set lp [set se(mapPath$n)]
	set lf [set se(mapFile$n)]
	set t  [set se(libTxt$n)]
	if {$lf!=""} {
		set wf [open $lp w]
		puts $wf [$t get 1.0 "end -2l"]
		close $wf
	}
	_listMapsInMenu_ $se(currMpFilePath)
	set se(libChanged) 0
}

proc _viewShader_ {} {
	global se gui
	set n $se(currLibLbox)
	toplevel .vw
	wm geometry .vw +[winfo pointerx .]+[winfo pointery .]
	wm transient .vw .
	set sname [[set se(SLlbox$n)] get [[set se(SLlbox$n)] curselection]]
	wm title .vw "Shader: $sname"
	bind .vw <Escape> {destroy .vw; grab .lw}
	_insertText_ .vw.t 46 30 grey45 white $gui(textFont) svText
	grab .vw
	focus .vw.t
	_viewShDef_ $n $sname
}

proc _viewShDef_ {n sname} {
	global se svText
	set t [set se(libTxt$n)]
	set i1 [$t search "Declare $sname =" 1.0 end]
	set i2 [$t search "Declare " "$i1 +1c" end]
	if {$i2==""} {set i2 end}
	$svText insert end "Declare $sname =\n"
	$svText insert end [$t get "$i1 +1l" $i2]
}
