proc _sceneOptionsWin_ {} {
	if [winfo exists .so] {wm deiconify .so; return}
	global se wl
	toplevel .so
	bind .so <Escape> {wm withdraw .so}
	# 
	# Commentare nella versione finale:
	# 
	#bind .so <Control-x> {destroy .so; source src/render.tcl}
	wm protocol .so WM_DELETE_WINDOW {wm withdraw .so}
	wm geometry .so +[expr [winfo x .]+40]+[expr [winfo y .]+40]
	wm transient .so .
	wm title .so "Rendering options"
	wm resizable .so 0 0
	frame .so.f1 -relief groove -bd 1.2
	frame .so.f2 -relief groove -bd 1.2
	pack .so.f1 .so.f2 -padx 2 -pady 2 -side left -fill both -anchor n
	#
	radiobutton .so.f1.rb -text "PointLights" -variable se(illType) -value sl -fg white
	checkbutton .so.f1.l1 -text "Upper left" -var se(lsa)
	checkbutton .so.f1.l2 -text "Lower left" -var se(lsb)
	checkbutton .so.f1.l3 -text "Upper right" -var se(lda)
	checkbutton .so.f1.l4 -text "Lower right" -var se(ldb)
	scale .so.f1.sc -orient horizontal -from 0.01 -to 2 -resolution 0.01 \
		-width 10 -variable se(illInt)
	_bindEnterLeave_ .so.f1.sc se(infoText) "Intensity factor"
	pack .so.f1.rb .so.f1.rb .so.f1.l1 .so.f1.l2 .so.f1.l3 .so.f1.l4 \
		 .so.f1.sc -anchor w
	#
	radiobutton .so.f2.rb -text "SkyLight" -variable se(illType) -value sk -fg white
	pack .so.f2.rb -anchor n
	_insertLbEn_ .so.f2.s 10 5 "Samples" se(illSamp)
	_insertLbEn_ .so.f2.b 10 5 "Brightness" se(illBrig)
	#
	_insertSeparator_ .so.f2.sep
	checkbutton .so.f2.f -text "Floor" -var se(floorOn)
	checkbutton .so.f2.w -text "Wall" -var se(wallOn)
	checkbutton .so.f2.ck -text "Checkered floor" -var se(floorChk)
	pack .so.f2.f .so.f2.ck .so.f2.w -anchor w
	_insertCbLbColor_ .so.f2.wc .so 8 "Wall/floor" {} wl n
	_insertLbMenu_ .so.f2.ob 10 8 " Object" \
		"Cylinder Sphere Torus Box Disc" "" {} se(prim)
	_insertCbLbColor_ .so.f2.bg . 8 "Background" {} se n
	.so.f2.bg.cc config -bg [_exaColor_ $se(red) $se(green) $se(blue)]
	.so.f2.wc.cc config -bg [_exaColor_ $wl(red) $wl(green) $wl(blue)]
}

proc _shTestScene_ {} {
	global tmpDir seText se wl
	set f [open $tmpDir/Vse_Scene.vib w]
	fconfigure $f -blocking 0
	set shDef  "Declare test = [$seText get 2.0 end]"
	foreach i $se(RAlist) {
		puts $f "ReadArchive \"$i\""
	}
	puts $f ""
	puts -nonewline $f $shDef
	puts $f "Background '$se(red), $se(green), $se(blue)'\n"
	puts $f "Camera \[\n\
	  (-0.019, 3.478, 1.300), (0.002, 0.116, -0.029), (0.0, 0.0, 1.0)\n\
	  FieldOfView 40.000\n\
	  Format (320,320)\n\
	  FrameAspectRatio -1.0"
	puts $f "\]\n"
	set pl1 "PointLight"
	set pl2 "Intensity '0.5, 0.5, 0.5' *$se(illInt) LightingAttributes 2"
	if {$se(illType)=="sk"} {
		puts $f "SkyLight ($se(illSamp), '1.0, 1.0, 1.0', $se(illBrig))"
	}
	if {$se(illType)=="sl"} {
		if $se(lsa) {puts $f "$pl1 \[ ( 3.6,4.0, 4.8) $pl2\]"}
		if $se(lsb) {puts $f "$pl1 \[ ( 5.0,4.0,-0.4) $pl2\]"}
		if $se(lda) {puts $f "$pl1 \[ (-3.6,4.0, 4.8) $pl2\]"}
		if $se(ldb) {puts $f "$pl1 \[ (-5.0,4.0,-0.4) $pl2\]"}
	}
	puts $f ""
	puts $f "Declare plain =
	Shader \[
		PlainSurface \[
			Color '$wl(red), $wl(green), $wl(blue)'
			Kd 0.9
		\]
	\]\n"
	puts $f "Declare checkered =
	Shader \[
		FunctionalSurface \[
			Color '1.0000, 1.0000, 1.0000' * Checker
			Kd 1.00
			Kb 0.80
			Ks 0.01
			BlinnSpecularBRDF 45
		\]
		Rotate (0,0,45)
	\]\n"
	if $se(wallOn) {
		puts $f "// Wall"
		puts $f "Shape \[ Disk ((0, 0, 0), (0, 0, 1), 100)
			Rotate (-90.0, 0, 0)
			Translate (0, -3, 0)
			plain
		\]\n"
	}
	if $se(floorOn) {
		if $se(floorChk) {set flMat checkered} else {set flMat plain}
		puts $f "// Floor"
		puts $f "Shape \[ Disk ((0, 0, 0), (0, 0, 1), 100)
			Translate (0, 0, -1)
			$flMat
		\]\n"
	}
	set prim {}
	switch $se(prim) {
		Cylinder {set prim "Shape \[ Cylinder ((0,0,-1),(0,0,1),0.8) test\]"}
		Sphere {set prim "Shape \[ Sphere ((0,0,0),1) test\]"}
		Torus {set prim "Shape \[ Torus ((0,0,0),(0,0,1),0.9,0.3) \
			Rotate (-30,0,0) test\]"}
		Box {set prim "Shape \[ Box ((-1,-1,-1),(1,1,1)) Scale (0.7,0.7,0.7) \
			Rotate (0,0,30) Translate (0.1,0,0) test\]"}
		Disc {set prim "Shape \[ Disk ((0,0,0),(0,0,1),1.2) Rotate (-40,0,0) test\]"}
	}
	puts $f $prim
	puts $f ""
	close $f
}

proc _shRender_ {} {
	global tmpDir nccomm se
	if {$se(currShName)==""} return
	_shTestScene_
	catch {eval exec [auto_execok start] \
		vlight $tmpDir/Vse_Scene -L -f -r 200 200 -o $tmpDir/Vse_$se(currShName)
	}
	set tgaName [file nativename $tmpDir/Vse_$se(currShName).tga]
	set pngName [file nativename $tmpDir/Vse_$se(currShName).png]
	if ![file exists $tgaName] return
	set nccomm {exec nconvert -quiet -out png -o $pngName -resize 150 150 $tgaName}
	if [catch $nccomm ncErr] return; # anche se il file tga e' incompleto
	if [file exists $pngName] {
		.f2.r.im config -image [image create photo -file $pngName]
	}
	focus .
}

proc _viewRenderLog_ {} {
	global tmpDir
	set fn $tmpDir/Vse_Scene.log
	if ![file exists $fn] {
		tk_messageBox -icon info -parent . -title "Vlight log" -type ok \
			-message "'Render' first !"
		return
	}
	set lf [open $fn r]
	tk_messageBox -icon info -parent . -title "Vlight log" -type ok -message [read $lf]
	close $lf
}
