proc _setShFile_ {type} {
	global se
	if {$type=="Open"} {set tit "Select shaders archive file"}
	if {$type=="Save"} {set tit "Create new shaders archive file"}
	set types {
    	{{Vse shader files}       {.vs}}
	}
	set iniDir [file dirname $se(currShFilePath)]
	set iniName $se(currShFileName)
	if [winfo exists .lsh] {; # Load shader ...
		set iniDir [file dirname $se(tmpShFilePath)]
		set iniName $se(tmpShFileName)
	}
	set fname [tk_get${type}File -filetypes $types \
			-defaultextension vs -title $tit -parent . \
			-initialdir $iniDir \
			-initialfile $iniName
		]
	if {$fname==""} return
	if [winfo exists .lsh] {; # Load shader ...
		set se(tmpShFilePath) $fname
		set se(tmpShFileName) [file tail $fname]
		.lsh.f2.im config -image $se(esIm)
		return
	}
	set se(currShFilePath) $fname
	set se(currShFileName) [file tail $fname]
}

proc _setMpFile_ {type} {
	global se
	if {$type=="Open"} {set tit "Select maps archive file"}
	if {$type=="Save"} {set tit "Create new maps archive file"}
	set types {
    	{{Vse maps files}       {.vm}}
	}
	set fname [tk_get${type}File -filetypes $types \
			-defaultextension vs -title $tit -parent .cmp \
			-initialdir [file dirname $se(currMpFilePath)] \
			-initialfile $se(currMpFileName)
		]
	if {$fname==""} return
	set se(currMpFilePath) $fname
	set se(currMpFileName) [file tail $fname]
	_listMapsInMenu_ $se(currMpFilePath)
}

proc _setupWin_ {} {
	if [winfo exists .su] return
	global se
	toplevel .su
	wm geometry .su +[winfo pointerx .]+[winfo pointery .]
	wm transient .su .
	wm title .su "Vse setup"
	wm resizable .su 0 0
	set f [open data/settings.tcl r]
	gets $f l1; gets $f l2; gets $f l3; gets $f l4
	set f1 [lindex $l1 end]
	set f2 [lindex $l3 end]
	set se(setupShFilePath) [lindex $l2 end]
	set se(setupMpFilePath) [lindex $l4 end]
	close $f
	frame .su.f1 -relief ridge -bd 2; # archive file
	_bindEnterLeave_ .su.f1 se(infoTextSU) "Default shader archive file"
	label .su.f1.lb -text $f1
	button .su.f1.b -image $se(opIm) -command "_setSetup_ Sh $f1"
	frame .su.f1a -relief ridge -bd 2; # maps file
	_bindEnterLeave_ .su.f1a se(infoTextSU) "Default SOC archive file"
	label .su.f1a.lb -text $f2
	button .su.f1a.b -image $se(opIm) -command "_setSetup_ Mp $f2"
	pack .su.f1.lb .su.f1a.lb -side left -anchor w
	pack .su.f1.b .su.f1a.b -side right -fill y -anchor e
	label .su.ms -width 36 -fg white -text $se(infoTextSU) \
		-textvariable se(infoTextSU)
	pack .su.f1 .su.f1a .su.ms -fill x
	_insertApplyDismiss_ .su.f2 Save .su . _saveSetupFile_
}

proc _setSetup_ {type fname} {
	global se
	if {$type=="Sh"} {
		set ext .vs
		set types {{{Vse files} .vs}}
		set iniDir [file dirname $se(setupShFilePath)]
		set lb .su.f1.lb
		set v se(setupShFilePath)
	}
	if {$type=="Mp"} {
		set ext .vm
		set types {{{Vse files} .vm}}
		set iniDir [file dirname $se(setupMpFilePath)]
		set lb .su.f1a.lb
		set v se(setupMpFilePath)
	}
	set iniName $fname
	set fname [tk_getOpenFile -filetypes $types \
			-defaultextension $ext -title "Select file" -parent .su \
			-initialdir $iniDir \
			-initialfile $iniName
		]
	if {$fname==""} return
	set $v $fname
	$lb config -text [file tail $fname]
}

proc _saveSetupFile_ {} {
	global se
	set f1 [.su.f1.lb cget -text]
	set f2 [.su.f1a.lb cget -text]
	set f [open data/settings.tcl w]
	puts $f "set se(currShFileName) $f1"
	puts $f "set se(currShFilePath) $se(setupShFilePath)"
	puts $f "set se(currMpFileName) $f2"
	puts $f "set se(currMpFilePath) $se(setupMpFilePath)"
	close $f
	grab .
	destroy .su
}

proc _saveWorkspace_ {} {
	global se
	set types {{{Vse workspace files} {.vsw}}}
	set fname [tk_getSaveFile -filetypes $types \
			-defaultextension vsw -title "Save Vse workspace" -parent . \
			-initialdir $se(currWsDir)
		]
	if {$fname==""} return
	set f [open $fname w]
	foreach s [lsort $se(currList)] {
		global $s
		global [set $s] $s.path
		set p [set $s.path]
		# p==PATH s==SHADER_NAME
		puts $f "$p $s"
	}
	close $f
	set se(currWsDir) [file dirname $fname]
}

proc _loadWorkspace_ {wfile} {
	global se
	if {$wfile==""} {
		set types {{{Vse workspace files} {.vsw}}}
		set fname [tk_getOpenFile -filetypes $types \
				-defaultextension vsw -title "Open Vse workspace" -parent . \
				-initialdir $se(currWsDir)
			]
	} else {
		set fname $wfile
	}
	if {$fname==""} return
	_closeAll_
	set f [open $fname r]
	set notexists {File not found:}
	while {[gets $f line]>=0} {
		set sf [lindex $line 0]
		set sn [lindex $line 1]
		if [file exists $sf] {
			_loadShader_ $sf $sn
		} else {
			lappend notexists "\n$sf for shader '$sn'"
		}
	}
	if {$notexists != "File not found:"} {
		tk_messageBox -icon info -parent . -title "" -type ok \
			-message [join $notexists]
	}
	close $f
	set se(currWsDir) [file dirname $fname]
}
