proc _topShell_ {} {
	# 
	# Window di standard output
	# (_puts_ ... usa questa shell in sostituzione di puts stdout)
	# 
	global shell
	toplevel .shell
	wm geometry .shell +0+700
	wm title .shell "Output shell (indirizzare con '_puts_ ...')"
	wm transient .shell .
	frame .shell.t
	set shell [text .shell.t.txt -xscrollcommand {.shell.sx set} -exportselect false \
		-yscrollcommand {.shell.t.sy set} -wrap none -width 76 -font "courier 10" \
		-height 20 -cursor left_ptr]
	scrollbar .shell.t.sy -command {$shell yview} -orient vert
	scrollbar .shell.sx -command {$shell xview} -orient horiz
	frame .shell.b
	button .shell.b.b1 -text "Clear" -command "
		$shell delete 1.0 end
		$shell insert end {> }
	"
	button .shell.b.b2 -text "Wrap" -command "$shell config -wrap word"
	button .shell.b.b3 -text "Unwrap" -command "$shell config -wrap none"
	pack $shell -side left -fill both -expand 1
	pack .shell.t -fill both -expand 1
	pack .shell.t.sy -fill y -expand 1
	pack .shell.sx .shell.b -fill x
	pack .shell.b.b1 .shell.b.b2 .shell.b.b3 -side right -anchor e
	$shell insert end "> "
}

proc _puts_ {txt} {
	# 
	# Questa serve solo per la shell creata con _topShell_
	# Bisogna cancellarla nella versione finale o fare attenzione che non ci sia nessuna
	# chiamata a questa procedura, dato che richiama _topShell_
	# 
	if ![winfo exists .shell] _topShell_
	global shell
	set ii [$shell index "end -1l +2c"]
	$shell insert end $txt\n
	set ei [$shell index "end -2l lineend"]
	$shell insert end "> "
	$shell tag add txt $ii $ei
	$shell tag configure txt -background grey65
	$shell see end
}

proc _exaColor_ {r g b} {
	# 
	# RGB -> esadecimale
	# 
	set fred   [format %.0f [expr 65535*$r]]
	set fgreen [format %.0f [expr 65535*$g]]
	set fblue  [format %.0f [expr 65535*$b]]
	set color [format "#%04x%04x%04x" $fred $fgreen $fblue]
	return $color
}

proc _rgbColor_ {exacol} {
	# 
	# esadecimale -> RGB
	# 
	set rgbV1 [winfo rgb . $exacol]
	set r [format %.3f [expr [lindex $rgbV1 0]/65535.000]]
	set g [format %.3f [expr [lindex $rgbV1 1]/65535.000]]
	set b [format %.3f [expr [lindex $rgbV1 2]/65535.000]]
	return "$r $g $b"
}

proc _state_ {wgt state} {
	$wgt config -state $state
}

proc _delLine_ {i} {
	# 
	# Cancella una linea completa in seText
	# 
	global seText
	$seText delete "$i linestart" "$i linestart +1l"
}

proc _cursor_ {type} {
	global oText mess
	. config -cursor $type
	$oText config -cursor $type
	$mess config -cursor $type
	update
}

proc _bindEnterLeave_ {w var mess} {
	# 
	# var deve essere la textvar della label di info
	# 
	global se
	bind $w <Enter> "set $var [list $mess]"
	bind $w <Leave> "set $var {}"
}

proc _placeAtCenterOfScreen_ {w} {
	wm withdraw $w
	update
	set screenW [winfo vrootwidth .]
	set screenH [winfo vrootheight .]
	set wW [winfo width $w]
	set wH [winfo height $w]
	set wX [expr ($screenW/2)-($wW/2)]
	set wY [expr ($screenH/2)-($wH/2)]
	wm geometry $w +$wX+$wY
	wm deiconify $w
}

proc _exit_ {} {
	set answer [tk_messageBox -message "All unsaved data will be lost!\n\
		Do you really want to exit?" -parent . \
		-title "Exit Vse" -type okcancel -icon question]
	switch -- $answer {
		ok exit
		cancel {}
	}
}

