proc _ghostScale_ {} {
	global currScaleComm
	toplevel .p
	wm overrideredirect .p 1
	wm withdraw .p
	frame .p.f -relief raised -bd 1
	scale .p.f.s -orient horiz -width 10 -length 150 -fg blue
	entry .p.f.e
	pack .p.f
	pack .p.f.s -fill both -expand 1
# 	pack .p.f.e -fill both -expand 1
	bind .p.f.s <ButtonRelease-1> {
		wm withdraw .p
		if {$currScaleComm!="n"} {eval $currScaleComm}
	}
	bind .p.f <Leave> {wm withdraw .p}
	bind .p <Escape>  {wm withdraw .p}
}

proc _showGhostScale_ {x y var from to res comm} {
	global currScaleComm
	set currScaleComm $comm
	.p.f.s config -var $var -from $from -to $to -res $res
	set wx [winfo width .p]
	set wy [winfo height .p]
	wm geometry .p +[expr $x-$wx/2]+[expr $y-$wy/2]
	wm deiconify .p
	focus .p.f.s
}

proc _insertSeparator_ {path} {
	frame $path -relief raised -bd 2 -height 3
	pack $path -fill x -pady 2 -anchor n
}

proc _insertOptFrame_ {path lab} {
	frame $path -relief ridge -bd 2
	label $path.lb -text " $lab" -fg white
	pack $path -padx 2 -pady 2 -fill x -expand 1
	if {$lab!=""} {pack $path.lb -anchor w}
}

proc _insertOptFrameCb_ {path lab var} {
	frame $path -relief ridge -bd 2
	frame $path.f
	checkbutton $path.f.cb -text $lab -var $var
	pack $path -padx 2 -pady 2 -fill x -expand 1
	pack $path.f -fill x -expand 1
	pack $path.f.cb -side left -anchor w
}

proc _insertCbLbScale_ {path wdt txt var0 var from to res comm} {
	frame $path
	checkbutton $path.cb -text $txt -var $var0 -comm $comm
	label $path.lb -relief raised -width $wdt -textvar $var
	bind $path.lb <1> "_showGhostScale_ %X %Y $var $from $to $res [list $comm]"
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	if {$var0=={}} {$path.cb config -state disabled -indicatoron 0}
	pack $path.lb -side right
}

proc _insertCbLbColor_ {path w wdt label var0 var comm} {
	frame $path
	checkbutton $path.cb -anchor w -text $label -var $var0 -comm $comm
	label $path.cc -width $wdt -relief raised
	bind $path.cc <ButtonRelease-1> "_tkChooseColor_ $path $w $var [list $comm]"
	pack $path -fill x -anchor n
	pack $path.cb -side left
	pack $path.cc -side right
	if {$var0=={}} {$path.cb config -state disabled -indicatoron 0}
}

proc _insertCbLbEn_ {path wdt txt var0 var1 comm} {
	# 
	# var0 variabile di checkbutton
	# wdt -> larghezza entry, txt -> testo cb
	# var1 -> textvariable di entry
	# 
	frame $path
	checkbutton $path.cb -text $txt -var $var0 -bd 0 -comm $comm
	entry $path.en1 -width $wdt -textvar $var1
	bind $path.en1 <Key-Return> "eval $comm"
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.en1 -side right
}

proc _insertCbLbBt_ {path wdt txt var comm1 comm2} {
	frame $path
	checkbutton $path.cb -text $txt -var $var -comm $comm1
	label $path.lb -relief raised -width $wdt
	bind $path.lb <1> "[list $comm2]"
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.lb -side right
}

proc _insertCbLbMenu_ {path wdt txt entries accel var0 var comm} {
	global $var
	frame $path
	checkbutton $path.cb -text $txt -var $var0 -comm $comm
	label $path.mb -relief raised -width $wdt -textvar $var
	menu $path.mb.m -tearoff 0
	bind $path.mb <ButtonRelease-1> "tk_popup $path.mb.m %X %Y"
	set cnt 0
	foreach i $entries {
		set a [lindex $accel $cnt]
		$path.mb.m add command -label $i -accel $a -command "set $var $i; eval $comm"
		incr cnt
	}
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.mb -side right
}

proc _insertLbEn_ {path w1 w2 txt var} {
	# 
	# w1 -> larghezza label, w2 -> larghezza entry, txt -> testo label
	# var -> textvariable di entry
	# 
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	entry $path.en -width $w2 -textvar $var
	pack $path -fill x -anchor n
	pack $path.lb -side left -fill x -expand 1
	pack $path.en -side right
}

proc _insertLbMenu_ {path w1 w2 txt entries accel comm var} {
	global $var
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	label $path.mb -relief raised -width $w2 -textvar $var
	menu $path.mb.m -tearoff 0
	bind $path.mb <ButtonRelease-1> "tk_popup $path.mb.m %X %Y"
	set cnt 0
	foreach i $entries {
		set a [lindex $accel $cnt]
		$path.mb.m add command -label $i -accel $a -command "set $var $i; $comm"
		incr cnt
	}
	pack $path -fill x -anchor n
	pack $path.lb -side left
	pack $path.mb -side right
}

proc _insertText_ {path w h bg fg font name} {
	global gui $name
	frame $path
	frame $path.t
	set $name [
		text $path.t.txt -xscrollcommand "$path.sx set" -exportselection false \
		-yscrollcommand "$path.t.sy set" -wrap none -width $w -height $h \
		-font $font -bg $bg -fg $fg
	]
	scrollbar $path.t.sy -command "$path.t.txt yview" -orient vert
	scrollbar $path.sx -command "$path.t.txt xview" -orient horiz
	pack $path.t.txt -side left -fill both -expand 1
	pack $path.t.sy -fill y -expand 1
	pack $path.sx -fill x -side bottom
	pack $path.t -fill both -expand 1
	pack $path -fill both -expand 1
}

proc _insertLbox_ {path w lb} {
	frame $path
	label $path.lb -text $lb -relief sunken -bd 1.2
	listbox $path.l -height 8 -yscrollcommand "$path.s set" -exportselection false
	scrollbar $path.s -command "$path.l yview" -orient vert
	pack $path -fill x -expand 1
	if {$lb!=""} {pack $path.lb -side top -fill x -expand 1}
	pack $path.l -side left -fill x -expand 1
	pack $path.s -side right -fill y
	return $path.l
}

proc _insertUpDownDel_ {path lbox} {
	global se
	frame $path -relief sunken -bd 2
	button $path.up -image $se(upIm) -command "_listboxSeleMove_ $lbox - {} {}"
	button $path.dw -image $se(dwIm) -command "_listboxSeleMove_ $lbox + {} {}"
	button $path.dl -image $se(clIm) -command "_listboxSeleMove_ $lbox 0 {} {}"
	pack $path -fill x -expand 1
	pack $path.up $path.dw $path.dl -side left -fill x -expand 1
}

proc _insertUpDownDelSide_ {type path lbox1 lbox2 n} {
	global se
	if {$type=="r"} {
		set im $se(rgIm)
		set pk "pack $path.up $path.dw $path.dl $path.lt"
	}
	if {$type=="l"} {
		set im $se(lfIm)
		set pk "pack $path.lt $path.up $path.dw $path.dl"
	}
	frame $path -relief sunken -bd 2
	button $path.up -image $se(upIm) -command "_listboxSeleMove_ $lbox1 - {} $n"
	button $path.dw -image $se(dwIm) -command "_listboxSeleMove_ $lbox1 + {} $n"
	button $path.dl -image $se(clIm) -command "_listboxSeleMove_ $lbox1 0 {} $n"
	button $path.lt -image $im       -command "_listboxSeleMove_ $lbox1 {} $lbox2 $n"
	pack $path -fill x -expand 1
	eval $pk -side left -fill x -expand 1
}

proc _insertApplyDismiss_ {path txt w g comm} {
	frame $path -relief sunken -bd 2
	button $path.ok -text "$txt" -command $comm
	button $path.cn -text "Dismiss" -command "destroy $w; grab $g"
	pack $path -fill x -expand 1
	pack $path.cn $path.ok -side right -padx 2 -pady 2
	focus $w
}

proc _tkChooseColor_ {path w var comm} {
	global $var
	set ccol [$path.cc cget -bg]
	set col [tk_chooseColor -parent $w -initialcolor $ccol]
	if {$col==""} return
	$path.cc config -bg $col
	catch {_rgbColor_ $col} rgb
	set [set var](red) [lindex $rgb 0]
	set [set var](green) [lindex $rgb 1]
	set [set var](blue) [lindex $rgb 2]
	if {$comm!="n"} {eval $comm}
}
